Package: SMITE
Type: Package
Title: Significance-based Modules Integrating the Transcriptome and
        Epigenome
Version: 1.41.0
Date: 2021-11-21
Author: Neil Ari Wijetunga, Andrew Damon Johnston, John Murray Greally
Maintainer: Neil Ari Wijetunga <nawijet@gmail.com>,
 Andrew Damon Johnston <Andrew.Johnston@med.einstein.yu.edu>
Description: This package builds on the Epimods framework which
        facilitates finding weighted subnetworks ("modules") on
        Illumina Infinium 27k arrays using the SpinGlass algorithm, as
        implemented in the iGraph package. We have created a class of
        gene centric annotations associated with p-values and effect
        sizes and scores from any researchers prior statistical results
        to find functional modules.
License: GPL (>=2)
Depends: R (>= 3.5), GenomicRanges
Imports: scales, plyr, Hmisc, AnnotationDbi, org.Hs.eg.db, ggplot2,
        reactome.db, KEGGREST, BioNet, goseq, methods, IRanges, igraph,
        Biobase,tools, S4Vectors, geneLenDataBase, grDevices, graphics,
        stats, utils
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
biocViews: ImmunoOncology, DifferentialMethylation,
        DifferentialExpression, SystemsBiology,
        NetworkEnrichment,GenomeAnnotation,Network, Sequencing, RNASeq,
        Coverage
URL: https://github.com/GreallyLab/SMITE
BugReports: https://github.com/GreallyLab/SMITE/issues
NeedsCompilation: no
git_url: https://git.bioconductor.org/packages/SMITE
git_branch: devel
git_last_commit: 1ac1d56
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
Packaged: 2026-04-29 01:13:08 UTC; biocbuild

setGeneric(
    name="stoufferTest",
    def=function(pvalues, weights)
    {
        standardGeneric("stoufferTest")
    }
)

setGeneric(
    name="annotationOutput",
    def=function(pvalue_annotation)
    {
        standardGeneric("annotationOutput")
    }
)

setGeneric(
    name="returnPvalueCol",
    def=function(pval_object, col_name)
    {
        standardGeneric("returnPvalueCol")
    }
)

setGeneric(
    name="makePvalueAnnotation",
    def=function(data, other_data=NULL, other_tss_distance=10000,
                 promoter_upstream_distance=1000, promoter_downstream_distance=1000,
                 strand_col=NULL, gene_name_col=NULL)
    {
        standardGeneric("makePvalueAnnotation")
    }
)

setGeneric(
    name="convertGeneIds",
    def=function(gene_IDs, ID_type, ID_convert_to, delim=NULL, verbose=FALSE)
    {
        standardGeneric("convertGeneIds")
    }
)


setGeneric(
    name="annotateExpression",
    def=function(pvalue_annotation, expr_data, effect_col=NULL, pval_col=NULL)
    {
        standardGeneric("annotateExpression")
    }
)


setGeneric(
    name="annotateModification",
    def=function(pvalue_annotation, mod_data, weight_by=NULL,
                 weight_by_method="Stouffer", mod_included=NULL, mod_corr=TRUE,
                 mod_type="methylation", verbose=FALSE)
    {
        standardGeneric("annotateModification")
    }
)


setGeneric(
    name="removeModification",
    def=function(pvalue_annotation, mod_type="methylation")
    {
        standardGeneric("removeModification")
    }
)


setGeneric(
    name="makePvalueObject",
    def=function(pvalue_annotation, effect_directions=NULL)
    {
        standardGeneric("makePvalueObject")
    }
)


setGeneric(
    name="plotDensityPval",
    def=function(pvalue_annotation, ref="expression_pvalue", ...)
    {
        standardGeneric("plotDensityPval")
    }
)

setGeneric(
    name="normalizePval",
    def=function(pvalue_annotation, trans, ref="expression_pvalue", method="rescale")
    {
        standardGeneric("normalizePval")
    }
)


setGeneric(
    name="scorePval",
    def=function(pvalue_annotation, weights)
    {
        standardGeneric("scorePval")
    }
)

setGeneric(
    name="runSpinglass",
    def=function(pvalue_annotation, network, random_alpha = 0.05, gam = 0.5,
                 node_alpha = 0.05, maxsize = 500, minsize = 8, num_iterations = 1000,
                 simplify=TRUE)
    {
        standardGeneric("runSpinglass")
    }
)



setGeneric(
    name="runBioNet",
    def=function(pvalue_annotation, network, alpha = 0.05)
    {
        standardGeneric("runBioNet")
    }
)

setGeneric(
    name="plotModule",
    def=function(pvalue_annotation, p_thresh=0.05, which_network=1, goseq=FALSE,
                 layout="fr",legend=TRUE, namestyle="symbol",
                 suppress_details=FALSE,
                 meth_hi_col="blue", meth_low_col="yellow1",
                 meth_mid_col="gray90", exp_hi_col="red1",
                 exp_low_col="chartreuse1", exp_mid_col="gray90",
                 label_scale=TRUE, label_shadow=FALSE, compare_plot=FALSE, pdf_out=NULL)
    {
        standardGeneric("plotModule")
    }
)


setGeneric(
    name="runGOseq",
    def=function(pvalue_annotation, p_thresh=0.05, supply_cov=TRUE, coverage=NULL, type="reactome")
    {
        standardGeneric("runGOseq")
    }
)


setGeneric(
    name="searchGOseq",
    def=function(pvalue_annotation, search_string, wholeword=FALSE)
    {
        standardGeneric("searchGOseq")
    }
)



setGeneric(
    name="extractGOseq",
    def=function(pvalue_annotation, which_network=NULL)
    {
        standardGeneric("extractGOseq")
    }
)


setGeneric(
    name="plotCompareScores",
    def=function(pvalue_annotation, x_name, y_name, ...)
    {
        standardGeneric("plotCompareScores")
    }
)


setGeneric(
    name="extractModification",
    def=function(pvalue_annotation, mod_type="methylation")
    {
        standardGeneric("extractModification")
    }
)

setGeneric(
    name="extractExpression",
    def=function(pvalue_annotation)
    {
        standardGeneric("extractExpression")
    }
)

setGeneric(
    name="extractModSummary",
    def=function(pvalue_annotation)
    {
        standardGeneric("extractModSummary")
    }
)

setGeneric(
    name="extractScores",
    def=function(pvalue_annotation)
    {
        standardGeneric("extractScores")
    }
)

setGeneric(
    name="addShadowText",
    def=function(x, y=NULL, labels, col='white', bg='black',
                 theta=seq(pi/4, 2*pi, length.out=8), r=0.1, ...)
    {
        standardGeneric("addShadowText")
    }
)


setGeneric(
    name="extractModules",
    def=function(pvalue_annotation, which_module=NULL)
    {
        standardGeneric("extractModules")
    }
)

setGeneric(
    name="highScores",
    def=function(pvalue_annotation, alpha=0.05)
    {
        standardGeneric("highScores")
    }
)

## ----warning=FALSE, message=FALSE, eval=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=50), echo=TRUE, results='hide'----
options(stringsAsFactors=FALSE)
library(SMITE)

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE-------
## Load methylation data ##
data(methylationdata)
head(methylation)
## Replace zeros with minimum non-zero p-value ##
methylation[,5] <- replace(methylation[,5], methylation[,5]==0, 
                           min(subset(methylation[,5], methylation[,5]!=0), na.rm=TRUE))

## Remove NAs from p-value column ##
methylation <- methylation[-which(is.na(methylation[, 5])), ] 

## ----warning=FALSE, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE----
## Load fake genes to show expression conversion ##
data(genes_for_conversiontest)
genes[,1] <- convertGeneIds(gene_IDs=genes[,1], ID_type="refseq", ID_convert_to="symbol")

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=FALSE------
# ## This is just an example of how to pre-process data ##
# expression <- expression[-which(is.na(expression[, 1])), ]
# expression <- split(expression, expression[, 1])
# expression <- lapply(expression, function(i){
#     if(nrow(as.data.frame(i)) > 1){
#         i <- i[which(i[, 3] == min(i[, 3], na.rm=TRUE))[1], ]
#         }
#     return(i)})
# expression <- do.call(rbind, expression)
# expression <- expression[,-1]
# expression[, 2] <- replace(expression[, 2],expression[, 2] == 0,
#                           min(subset(expression[, 2], expression[, 2] != 0), na.rm=TRUE))

## ----warning=FALSE, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE----
## Load expression data ##
data(curated_expressiondata)

## View data ##
head(expression_curated)


## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE-------
## Load hg19 gene annotation BED file ##
data(hg19_genes_bed)

## Load histone modification file ##
data(histone_h3k4me1)

## View files ##
head(hg19_genes)
head(h3k4me1)

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=50), eval=TRUE-------
test_annotation <- makePvalueAnnotation(data=hg19_genes, other_data=list(h3k4me1=h3k4me1), 
                                        gene_name_col=5, other_tss_distance=5000, 
                                        promoter_upstream_distance=1000, promoter_downstream_distance=1000) 

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=50), eval=TRUE-------
test_annotation <- annotateExpression(pvalue_annotation=test_annotation, expr_data=expression_curated, 
                                      effect_col=1, pval_col=2)

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=45), eval=FALSE------
# test_annotation <- annotateModification(test_annotation, methylation, weight_by_method="Stouffer",
#                                       weight_by=c(promoter="distance", body="distance", h3k4me1="distance"),
#                                       verbose=TRUE, mod_corr=FALSE, mod_type="methylation")

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=50), eval=FALSE, fig.width= 9----
# ## See expression data ##
# head(extractExpression(test_annotation))
# 
# ## See the uncombined p-values for a specific or all modType(s) ##
# extractModification(test_annotation, mod_type="methylation")
# 
# ## See the combined p-value data.frame ##
# head(extractModSummary(test_annotation))

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=35), eval=FALSE------
# test_annotation <- makePvalueObject(test_annotation, effect_directions=c(methylation_promoter="decrease",
#                                                                          methylation_body="increase", methylation_h3k4me1="bidirectional"))

## ----echo=FALSE, eval=TRUE----------------------------------------------------
## Because runSpinglass and scorePval are computationally intensive we simply load already ran data instead of evaluating the code.
data(test_annotation_score_data)

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=35), eval=TRUE-------
## Plot density of p-values ##
plotDensityPval(pvalue_annotation=test_annotation, ref="expression")

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=35), eval=TRUE, fig.width=9, fig.height=5----
## Normalize the p-values to the range of expression ##
test_annotation <- normalizePval(test_annotation, ref="expression", 
                                 method="rescale")

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=35), eval=TRUE, fig.width=8----
plotCompareScores(test_annotation, x_name="expression", y_name="methylation_promoter")

## ----long-compute-time, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=45), eval=FALSE----
# #score with all four features contributing
# test_annotation <- scorePval(test_annotation, weights=c(methylation_promoter=.3,
#                                                         methylation_body=.1,
#                                                         expression=.3,
#                                                         methylation_h3k4me1=.3))

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=45), eval=FALSE------
# ## load REACTOME ##
#  load(system.file("data","Reactome.Symbol.Igraph.rda", package="SMITE"))
# ## Run Spin-glass ##
# test_annotation <- runSpinglass(test_annotation, network=REACTOME, maxsize=50, num_iterations=1000)
# 
# ## Run goseq on individual modules to determine bias an annotate functions ##
# test_annotation <- runGOseq(test_annotation, supply_cov=TRUE, coverage=read.table(system.file(
#     "extdata", "hg19_symbol_hpaii.sites.inbodyand2kbupstream.bed.gz", package="SMITE")),
#     type="kegg")

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE, fig.width=10, fig.height=9----
## search goseq output for keywords ##
searchGOseq(test_annotation, search_string="cell cycle")

## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE, fig.width=10, fig.height=9----
## Draw a network ##
plotModule(test_annotation, which_network=6, layout="fr", label_scale=TRUE, compare_plot = FALSE)
## Compare two networks ##
plotModule(test_annotation, which_network=c(4,6), layout="fr", label_scale=TRUE, compare_plot = TRUE)


## ----tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE, fig.width=12,fig.height=6----
## Draw a network with goseq analysis ##
plotModule(test_annotation, which_network=1, layout="fr", goseq=TRUE, label_scale=FALSE)

##Classes

setClass(
    Class="PvalueObject",
    representation=representation(
        pval_data="data.frame",
        effect_data="data.frame",
        genes="character",
        signs_index="data.frame",
        scores="data.frame",
        trans="numeric",
        scoring_vector="numeric",
        module_output="list")
)

setClass(
    Class="PvalueAnnotation",
    representation=representation(
        annotation="GRangesList",
        modifications="GRangesList",
        expression="ExpressionSet",
        score_data="PvalueObject"),
    prototype=list(
        annotation=GRangesList(),
        modifications=GRangesList()
    ))

setMethod(
    f="plotCompareScores",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, x_name, y_name, ...)
    {
        pval_data <- slot(slot(pvalue_annotation, "score_data"), "pval_data")
        pval_col_names <- colnames(pval_data)
        effect_data <- slot(slot(pvalue_annotation, "score_data"), "effect_data")
        effect_col_names <- colnames(effect_data)

        if(all(!grepl(x_name, pval_col_names)))
        {
            stop(paste("Provided x_name was not one of the following:",
                    paste(pval_col_names, collapse=",")))
        }

        if(all(!grepl(y_name, pval_col_names)))
        {
            stop(paste("Provided y_name was not one of the following:",
                    paste(pval_col_names, collapse=",")))
        }

        if(length(grep(x_name, pval_col_names)) > 1)
        {
            stop(paste("Provided x_name was not unique"))
        }

        if(length(grep(y_name, colnames(pval_col_names))) > 1)
        {
            stop(paste("Provided y_name was not unique"))
        }

        x <- (-log(abs(as.numeric(pval_data[[grep(x_name, pval_col_names)]])))*
                  sign(effect_data[[grep(x_name, effect_col_names)]]))

        y <- (-log(abs(as.numeric(pval_data[[grep(y_name, pval_col_names)]])))*
                  sign(effect_data[[grep(y_name, effect_col_names)]]))

        ggplot(data=data.frame(x=x, y=y), aes(x=x, y=y))+
            stat_binhex(bins=50)+
            geom_hline(yintercept=0, colour="red", linetype = "longdash")+
            geom_vline(xintercept=0, colour="red", linetype = "longdash")+
            labs(title = paste(y_name, "vs", x_name,
                               "p-values comparing effect direction"),
            x=paste(x_name, "Score * Effect Direction"), y=paste(y_name,
            "Score * Effect Direction"))

    }
)


setMethod(
    f="plotModule",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, p_thresh=0.05, which_network=1, goseq=FALSE,
                        layout="fr", legend=TRUE, namestyle="symbol",
                        suppress_details=FALSE, meth_hi_col="blue",
                        meth_low_col="yellow1", meth_mid_col="gray90",
                        exp_hi_col="red1", exp_low_col="chartreuse1",
                        exp_mid_col="gray90", label_scale=TRUE, label_shadow=FALSE,
                        compare_plot=FALSE, pdf_out=NULL)
    {
        
        module_output <- slot(slot(pvalue_annotation, "score_data"), "module_output")
        
        if(!is.null(pdf_out)){
            unlink(pdf_out)
            if(compare_plot==TRUE){
                pdf(pdf_out, width=24, height=8.5)
            }
            else {
                pdf(pdf_out, width=16, height=8.5)
            }
        }
        
        ## if two side by side plots are not needed
        if(compare_plot == FALSE){
            ## no pdf
            par(mfrow=c(1,1))
            if(is.null(pdf_out)){
                ##no goseq
                if(goseq == FALSE){
                    ##yes legend
                    if(legend == TRUE){
                        if(!names(dev.cur()) %in% c("RStudioGD","pdf")){
                            dev.new(height=10, width=12)
                        }
                    }
                    ##no legend
                    else{
                        if(!names(dev.cur()) %in% c("RStudioGD","pdf")){
                            dev.new(height=8, width=8)
                        }
                    }
                }
                ##yes goseq and legend
                else {
                    if(!names(dev.cur()) %in% c("RStudioGD","pdf")){
                        dev.new(height=10, width=16)
                    }
                }
            }
        }
        ##compare plot is TRUE
        else{
            legend <- FALSE
            goseq <- FALSE
            suppress_details <- TRUE
            if(!names(dev.cur()) %in% c("RStudioGD","pdf")){
                dev.new(height=10, width=20)
            }
            par(mfrow=c(1,2))
        }
        
        for(n_plot in which_network){ # This is the big loop, with n_plot being the chosen GoSeq networks
            if(goseq == TRUE){
                if(length(module_output$goseqOut) == 0){
                    stop("Goseq analysis has not been performed.")
                }
            }
            name.eid <- names(module_output$modules)[n_plot]
            eid <- module_output$modules[[n_plot]]
            network <- module_output$network
            stat <- extractScores(pvalue_annotation)
            pval <- exp(stat/(-2))
            
            if(class(network) == "graphNEL"){
                network <- igraph::igraph.from.graphNEL(network)
                adj_mat_network <- igraph::as_adjacency_matrix(network)
                stat.v <- stat[which(names(stat) %in%
                                         rownames(adj_mat_network))]
                stat.v <- stat.v[order(names(stat.v))]
                adj_mat_network <- adj_mat_network[order(
                    rownames(adj_mat_network)),
                    order(colnames(adj_mat_network))]
                temp_vstat <- apply(adj_mat_network, 1, function(v) return(v*stat.v)) 
                W <- (temp_vstat + t(temp_vstat))/2
                Graph_adj_mat <- igraph::graph_from_adjacency_matrix(
                    W, mode ="undirected", weighted=TRUE)
                igraph::V(Graph_adj_mat)$weight <- stat.v
                network <- Graph_adj_mat
            }

            vect2color <- function(v, palettev, breaks) {
                w <- v;
                for (i in 1:length(palettev)) {
                    w[which( v >= breaks[i] & v < breaks[i+1] )] = palettev[i]
                }
                return(w);
            }
            
            ## Vertex palette:
            vertexPalette.v <-
                colorRampPalette(c("white","gray85","gray65","salmon"))(50)
            vertexBreaks.v <- rev(-2*log(Hmisc::cut2(pval, g=50,
                                                     onlycuts=TRUE)))
            vertexBreaks.v[51] <- vertexBreaks.v[51]+0.001
            ## Edge palette: grey to black
            edgePalette.v <-
                colorRampPalette(c("white","gray85","gray65","salmon"))(50);
            edgeBreaks.v <- Hmisc::cut2(igraph::E(network)$weight, g=50,
                                        onlycuts=TRUE)

            ## Compute iGraph object
            h <- igraph::induced_subgraph(network, eid);
            stat.v <- stat[igraph::V(h)$name];
            pval.v <- pval[igraph::V(h)$name];
            pval.v[which(pval.v == 0)] <- 0.000000001

            par(mar=c(4, 0, 2, 0))
            ## Color edges between grey and red according to significance
            igraph::E(h)$color <- vect2color(igraph::E(h)$weight, edgePalette.v, edgeBreaks.v);
            ## Color nodes blue to yellow according to hyper/hypo-methylation
            igraph::V(h)$color <- vect2color(stat.v, vertexPalette.v, vertexBreaks.v);
            #### this is where I could Modify to allow other annotation names
            ## vl = unlist(entrez2symbol[V(h)$name])
            vl <- igraph::V(h)$name
            igraph::V(h)$color[which(1-pchisq(igraph::V(h)$weight,2) < p_thresh)] <- "red"
            igraph::E(h)$color[which(1-pchisq(igraph::E(h)$weight,4) < p_thresh)] <- "red"
            
            if(layout == "circle"){layout1 <- igraph::layout_in_circle(h)}
            if(layout == "fr"){layout1 <- igraph::layout_with_fr(h)}
            if(layout == "dh"){layout1 <- igraph::layout_with_dh(h)}
            if(layout == "kk"){layout1 <- igraph::layout_with_kk(h)}
            
            layout1_scaled <- cbind(scales::rescale(layout1[, 1], to=c(-1, 1)),
                                    scales::rescale(layout1[, 2], to=c(-1, 1)))
            
            counter <- 0
            while(counter < 2){
                plot(h, layout=layout1, ## same layout each time
                     vertex.label="",
                     vertex.frame.color="black",
                     vertex.label.dist=.1,
                     vertex.label.font=3, vertex.label.color="black",
                     vertex.size =
                         if(length(igraph::V(h)) < 50) { 15 }

                     else {15*13/length(igraph::V(h))},
                     edge.width = if(length(igraph::V(h))< 50) { 2 } else { 1 },
                     ylim=c(-1, 1.5), xlim=c(-1, 1)
                )
                
                halfCircle <- function(x, y, r, r2=.75, quarter=FALSE, start=0,
                                       end=pi, nsteps=30, col=NULL, lwd=1,
                                       border=NULL){
                    if(isTRUE(quarter))
                    {

                        rs <- seq(start, end, len=nsteps)
                        xc <- x+r*cos(rs)
                        yc <- y+r*sin(rs)
                        xc2 <- x+r*r2*cos(rs)
                        yc2 <- y+r*r2*sin(rs)
                        polygon(c(xc, rev(xc2)), c(yc, rev(yc2)), col=col,
                                lwd=lwd, border=border)

                    }
                    if(!isTRUE(quarter))
                    {
                        rs <- seq(start, end, len=nsteps)
                        xc <- x+r*cos(rs)
                        yc <- y+r*sin(rs)
                        polygon(xc, yc, col=col, lwd=lwd, border=border)
                    }
                }

                arctext <- function(x, y, r, start, end, what, cex=1){
                    delta=(end-start)/4
                    rs <- seq(start, end, len=3)
                    xc <- x+r*cos(rs[2])
                    yc <- y+r*sin(rs[2])
                    text(xc, yc, what, srt=180+atan2(((y+r*sin(rs[3]))-

                                                          (y+r*sin(rs[1]))),((x+r*cos(rs[3]))-(x+r*cos(rs[1]))
                                                          ))*180/pi, cex=cex )
                }
                
                methcol <- c(meth_low_col, meth_mid_col, meth_hi_col, "white")
                names(methcol) <- c("Low", "Med", "High", "NoData")
                expcol <- c(exp_low_col, exp_mid_col, exp_hi_col, "white")
                names(expcol) <- c("Low", "Med", "High", "NoData")

                pval_data <- slot(slot(pvalue_annotation, "score_data"), "pval_data")
                genes_score <- slot(pvalue_annotation, "score_data")@genes
                effect_data <- slot(slot(pvalue_annotation, "score_data"), "effect_data")
                signs_idx <- slot(slot(pvalue_annotation, "score_data"), "signs_index")
                if(any(suppress_details == FALSE, counter == 1)){
                    for(i in 1:nrow(layout1_scaled)){
                        halfCircle(x=layout1_scaled[i, 1], y=layout1_scaled[i, 2],
                                   r=ifelse(length(igraph::V(h)) < 50, 0.075, 0.025), start=pi/2,
                                   end=2*pi/2, quarter=TRUE, lwd=1,
                                   col=ifelse(!is.na(pval_data$expression_pvalue[which(
                                       genes_score %in% igraph::V(h)$name[i])]),
                                       expcol[ifelse(abs(pval_data$expression_pvalue[
                                           which(genes_score %in% igraph::V(h)$name[i])
                                           ]) < p_thresh, ifelse(sign(
                                               effect_data$expression_effect[which(
                                                   genes_score %in%
                                                       igraph::V(h)$name[i])]) ==
                                                   1, 3, 1), 2)], expcol[4])
                        )
                        
                        start <- pi
                        delta <- (3*pi/2)/nrow(signs_idx)
                        
                        for(j in signs_idx[, 3]){
                            
                            score_graph_col<-returnPvalueCol(slot(
                                pvalue_annotation, "score_data"),
                                j)[which(genes_score %in% igraph::V(h)$name[i])]
                            
                            halfCircle(x=layout1_scaled[i, 1],
                                       y=layout1_scaled[i, 2],
                                       r=ifelse(length(igraph::V(h)) <
                                                    50, 0.075, 0.025),
                                       start=start, end=start+delta, quarter=TRUE,
                                       col=ifelse(!is.na(score_graph_col),
                                                  methcol[ifelse(abs(score_graph_col) <
                                                                     p_thresh,
                                                                 ifelse(effect_data[, grep(j, colnames(
                                                                     effect_data))][which(genes_score %in%
                                                                                              igraph::V(h)$name[i])] == 1,
                                                                     3, 1), 2)],methcol[4])
                            )
                            start <- start+delta
                        }
                    }
                }
                if(any(legend == TRUE, counter == 1)){
                    if(any(suppress_details == FALSE, counter == 1)){
                        num_factors <- nrow(signs_idx)
                        halfCircle(x=-1.25, y=1.25, r=.4, start=pi/2, end=pi, quarter=TRUE)
                        start <- pi/2
                        delta <- pi/8
                        for(g in 1:4){
                            halfCircle(x=-1.25, y=1.25, r=.37, r2=.89, start=start+delta*(g-1),
                                       end=start+delta*g, col=expcol[g], quarter=TRUE)
                            arctext(x=-1.25, y=1.25, r=.35, start=start+delta*(g-1),
                                    end=start+delta*g, names(expcol)[g], cex=.5)
                        }
                        text(-1.25+1.2*cos(seq(start, start+delta*2, len=30)[15]),
                             1.25+.4*.75*sin(seq(start,start+delta*2, len=30)[15]),
                             "expression", cex=.6)
                        start <- pi
                        delta <- (3*pi/2)/num_factors
                        
                        for(j in signs_idx[, 3]){
                            halfCircle(x=-1.25, y=1.25, r=.4, start=start,
                                       end=start+delta, quarter=TRUE)
                            
                            for(g in 1:4){
                                start <- start
                                end <- start+delta
                                delta2 <- (end-start)/4
                                halfCircle(x=-1.25, y=1.25, r=.37, r2=.89,
                                           start=start+delta2*(g-1),
                                           end=start+delta2*g,
                                           col=methcol[g], quarter=TRUE)
                                arctext(x=-1.25, y=1.25, r=.35,
                                        start=start+delta2*(g-1),
                                        end=start+delta2*g,
                                        ifelse(num_factors<=4,
                                               names(methcol)[g],
                                               substring(names(methcol)[g],
                                                         1, 1)),
                                        cex=.5)
                            }

                            text(-1.25+.57*cos(seq(start, start+delta, len=30)[15]),
                                 1.25+.57*.75*sin(seq(start, start+delta, len=30)[15]),
                                 paste(strsplit(j, "_")[[1]], collapse="\n"), cex=.6)
                            start <- start+delta
                        }
                    }
                    halfCircle(x=-1.25, y=1.25, r=.3, end=2*pi, col="white")

                    vertexPalette.v[which(
                        vertexBreaks.v >= min(igraph::V(h)$weight[which(
                            igraph::V(h)$weight >= qchisq(1-p_thresh,2))])) - 1] <- "red"
                    
                    points(seq(-1.45, -1.05, length.out=50), rep(1.35, 50),
                           col=vertexPalette.v, pch=15, cex=2.5)
                    
                    text(-1.20, 1.44, expression('node             ',Chi[2]^2))
                    text(-1.45, 1.295, round(vertexBreaks.v[1], 2))
                    text(-1.25, 1.295, round(vertexBreaks.v[26], 2))
                    text(-1.07, 1.295, paste(">",round(qchisq(1-p_thresh,2), 2),sep=""))
                    
                    if(length(which(
                        igraph::E(h)$weight >= qchisq(1-p_thresh, 4))) > 0){
                        
                        edgePalette.v[which(
                            edgeBreaks.v >= min(igraph::E(h)$weight[which(
                                igraph::E(h)$weight >= qchisq(1-p_thresh, 4))]))-1] <- "red"
                    }
                    points(seq(-1.45, -1.05, length.out=50), rep(1.15, 50),
                           col=edgePalette.v, pch=15, cex=2.5)
                    text(-1.20, 1.24, expression('edge             ',Chi[4]^2))
                    text(-1.45, 1.095, round(edgeBreaks.v[1], 2))
                    text(-1.25, 1.095, round(edgeBreaks.v[26], 2))
                    text(-1.07, 1.095, paste(">", round(qchisq(1-p_thresh,4), 2), sep=""))
                }
                
                if(label_shadow==T){addShadowText(layout1_scaled[, 1], layout1_scaled[, 2], vl, font=2,
                                                  cex=if(label_scale == TRUE){
                                                      scales::rescale(stat.v, to=(c(.5, 2)))
                                                  }
                                                  else{.5},
                                                  bg="white", col="black")}
                if(label_shadow==F){text(layout1_scaled[, 1], layout1_scaled[, 2], vl, font=2,
                                         cex=if(label_scale == TRUE){
                                             scales::rescale(stat.v, to=(c(.5, 2)))
                                         }
                                         else{.5},
                                         bg="white", col="black")}
                if(namestyle == "refseq"){
                    ref2eg <- AnnotationDbi::as.list(org.Hs.eg.db::org.Hs.egREFSEQ2EG)
                    eg2sym <- AnnotationDbi::as.list(org.Hs.eg.db::org.Hs.egSYMBOL)
                    text(layout1_scaled[, 1], layout1_scaled[, 2]-.05,
                         sapply(vl,
                                function(k){
                                    ifelse(is.null(ref2eg[[k]]), return(NA),
                                           return(eg2sym[[ref2eg[[k]]]]))
                                })
                    )
                    
                    text(0, 1.65, paste("Network built around", name.eid,
                                        ifelse(is.null(ref2eg[[name.eid]]), NA,
                                               eg2sym[[ref2eg[[name.eid]]]])))
                }
                if(namestyle == "symbol"){
                    text(0, 1.7, paste(
                        "Network built around", name.eid, "\nChi-square P-value=",
                        round(module_output$moduleStats[[n_plot]][2],4)))
                }
                
                if(goseq == TRUE){
                    if(nrow(module_output$goseqOut[[n_plot]]) > 0){
                        
                        text("Num\nGenes", x=1.35, y=1.6, font=2)
                        text("Enriched\nPathway/Term", x=2, y=1.6, font=2)
                        for(i in 1:nrow(module_output$goseqOut[[n_plot]])){
                            text(module_output$goseqOut[[n_plot]][i, 4], x=1.3,
                                 y=seq(1.4, -1, length.out=nrow(module_output$goseqOut[[n_plot]]))[i],
                                 adj = c(0, 0))
                            text(module_output$goseqOut[[n_plot]][i, 6], x=1.5,
                                 y=seq(1.4, -1, length.out=nrow(module_output$goseqOut[[n_plot]]))[i],
                                 adj= c(0, 0))
                        }
                        
                    }
                    else {
                        text("No enriched terms from\nGoseq", x=1.5, y=1.6, font=2)
                        
                    }
                }
                
                if(counter == 1){break}
                counter <- 2
            }
            
            if(is.null(pdf_out)){
                if(n_plot != which_network[length(which_network)]){
                    message("Press key to go to next plot")
                    readline()
                }
            }
        }
        if(!is.null(pdf_out)){dev.off()}
    }
)

setMethod(
    f="plotDensityPval",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, ref="expression_pvalue", ...)
    {
        palette(c("red", "green", "blue", "gold", "orange",
                        "purple", "magenta"))
        pval_data <- slot(slot(pvalue_annotation, "score_data"), "pval_data")
        pval_col_names <- colnames(pval_data)

        if(!any(grepl(ref, pval_col_names))){
            stop("paste(Reference is not one of the available:",
                 pval_col_names)
        }
        if(length(grep(ref, pval_col_names)) > 1){
            stop("Reference was not specific enough.")
        }

        ref <- pval_col_names[grep(ref, pval_col_names)]
        nonref <- pval_col_names[which(!grepl(ref, pval_col_names))]
        dens_range <- lapply(pval_data,
                             function(i){
                                dens <- density(as.numeric(i), na.rm=TRUE)
                                x <- dens$x
                                y <- dens$y
                                return(as.data.frame(cbind(x,y)))
                             }
                     )
        dens_range <- do.call(rbind, dens_range)
        x_range <- range(dens_range[,1])
        y_range <- range(dens_range[,2])
        y_range[2] <- y_range[2]+diff(y_range)*.1

        if(!names(dev.cur()) %in% c("RStudioGD")){
            par(mar=c(4,4,4,10), xpd=FALSE)
        }
        else{
            par(mar=c(4,4,4,4))
        }
        plot.new()
        plot.window(xlim=x_range, ylim=y_range)
        axis(1)
        axis(2)
        box()
        title("Density of P-values/Scores", xlab="P-values",
              ylab="Density")

        score_sign_idx <- slot(slot(pvalue_annotation, "score_data"), "signs_index")
        sapply(score_sign_idx[, 3], function(i){
            message(paste("Plotting: ", i))
            if(!all(is.na(pval_data[[grep(i, pval_col_names)]]))){
                lines(density(abs(as.numeric(pval_data[[grep(i, pval_col_names)]])),
                              na.rm=TRUE), col= which(score_sign_idx[, 3] == i))
            }
        })

        lines(density(abs(
            returnPvalueCol(slot(pvalue_annotation, "score_data"), ref)
            ), na.rm=TRUE), col="black")

        legend(x_range[2]+.01, y_range[2]+.01, gsub("_", "\n", c(paste(
            strsplit(ref, "_pvalue")[[1]], "(REF)"), score_sign_idx[, 3])),
            fill=c("black", 1:length(score_sign_idx[, 3])), xpd=TRUE,bty="n")
    }
)

setMethod(
    "show",
    signature="PvalueAnnotation",
    function(object){
        cat("*** Class P-Value Annotation, method Show *** \n")
        lengthexpdata <- min(10,
                             nrow(Biobase::pData(slot(object, "expression"))))
        nrowShow <- min(10,nrow(unlist(slot(object,"modifications"))))
        if(lengthexpdata != 0){
            cat(" First 10 Expression data are shown: \n")
            print(Biobase::pData(slot(object,"expression"))[1:lengthexpdata,],
                        quote=FALSE)
        }
        else{}
        if(length(unlist(slot(object,"modifications"))) != 0){
            for(i in unique(unlist(slot(object,"modifications"))$type)){
                cat(paste( " First 10 rows of", i, " data are shown: \n"))
                print(subset(unlist(slot(object,"modifications")),
                             unlist(slot(object,"modifications"))$type ==
                                 i)[1:nrowShow,])
            }

        }
        else{}

        if(nrow(slot(slot(object,"score_data"),"scores")) != 0){
            cat(paste( " First 10 rows of scores  are shown: \n"))
            print(slot(slot(object,"score_data"),"scores")[1:nrowShow,])
        }
        else{}
        cat("******* End Show (pvalue.object) ******* \n")
    }
)

setMethod(
    "show",
    signature="PvalueObject",
    function(object){
        cat("*** Class P-Value Object, method Show *** \n")

        if(nrow(slot(object, "pval_data")) != 0){
            cat(" First 10 rows of pval_data data are shown: \n")
            temp <- slot(object, "pval_data")[1:10,]
            rownames(temp) <- slot(object, "genes")[1:10]
            print(temp)
        }
        else{}

        if(nrow(slot(object, "effect_data"))!=0){
            cat(" First 10 rows of effect_data data are shown: \n")
            temp <- slot(object, "effect_data")[1:10,]
            rownames(temp) <- slot(object, "genes")[1:10]
            print(temp)
        }
        else{}

        if(nrow(slot(object, "signs_index")) !=0 ){
            cat("Signs Index: \n")
            print(slot(object, "signs_index"))
        }
        else{}
        if(nrow(slot(object, "scores")) !=0 ){
            cat(" First 10 Scores are shown: \n")
            temp <- slot(object, "scores")[1:10,]
            names(temp) <- slot(object, "genes")[1:10]
            print(temp)
        }
        else{}

        if(length(slot(object,"module_output")) != 0){
            if(slot(object,"module_output")$moduleType == "spinglass"){
                cat("Spinglass data has been loaded \n")
            }
            if(slot(object,"module_output")$moduleType == "BioNet"){
                cat("BioNet data has been loaded \n")
            }
            if(length(slot(object,"module_output")$goseqOut) > 0){
                cat("GoSeq analysis has been loaded \n")
            }
        }
        cat("******* End Show (pvalue.object) ******* \n")
    }
)

setMethod(
    f="annotationOutput",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation){
        metadata_sum <- slot(slot(pvalue_annotation, "modifications"), "metadata")$m_summary
        metadata_sum <- cbind(rownames(metadata_sum), metadata_sum)
        colnames(metadata_sum)[1] <- "genes"
        if(nrow(Biobase::pData(pvalue_annotation@expression)) > 0){

            exprs <- Biobase::pData(pvalue_annotation@expression)
            exprs <- cbind(rownames(exprs), exprs)
            metadata_sum <- merge(metadata_sum, exprs, by=1, all=TRUE)
        }
        metadata_sum
    }
)

setMethod(
    f="returnPvalueCol",
    signature="PvalueObject",
    definition=function(pval_object, col_name){

        return(slot(pval_object,
                    "pval_data")[, grep(col_name,
                                        colnames(slot(pval_object,
                                                      "pval_data")))])
    }
)

##SMITE_1_0_2 10/9/2015


##internal function to perform a Stouffer's test for p value combination

setMethod(
    f="stoufferTest",
    signature="vector",
    definition=function(pvalues, weights)
    {
        if(is.null(weights)){
            weights <- rep(1, length(pvalues))/length(pvalues)
        }

        Zi <- qnorm(1-pvalues/2)
        Z  <- sum(weights*Zi)/sqrt(sum(weights^2))
        new_pvalues <- (1-pnorm(Z))*2
        new_pvalues <- replace(new_pvalues,new_pvalues < .0000000000000001, .0000000000000001)
        new_pvalues <- replace(new_pvalues, new_pvalues > .9999999999999999, .9999999999999999)
        new_pvalues
    }
)

##SMITE Functions

setMethod(
    f="makePvalueAnnotation",
    signature="ANY",
    definition=function(data, other_data=NULL, other_tss_distance=10000,
                        promoter_upstream_distance=1000, promoter_downstream_distance=1000,
                        strand_col=NULL, gene_name_col=NULL)
    {
        ##create a Granges data object
        if(!inherits(data, "GRanges")){
            if(is.null(gene_name_col)){
                stop("Gene name column must be specified if GRanges not given")
            }
            ##if the strand column was not specified auto-detect
            if(is.null(strand_col)){
                strand_col <- which(data[1, ] %in% c("+", "-"))[1]
            }
            data_grange <- GenomicRanges::GRanges(seqnames=data[, 1],
                                   ranges=IRanges::IRanges(start=data[, 2], end=data[, 3]),
                                   name=data[, gene_name_col],
                                   strand=data[, strand_col])
        }
        else {
            data_grange <- data
            data_grange$score <- NULL
        }
        if(any(duplicated(data_grange$name)))
        {
            message("Genes are duplicated.  Removing duplicates")
            data_grange <-
                subset(data_grange,!duplicated(data_grange$name))
        }

        data_grange$feature <- "original"

        if(!is.null(other_data)){
            if(is.null(names(other_data))){
                otherdata_names <- paste("other", 1:length(other_data), sep="")
                names(other_data) <- otherdata_names
            }
            else{
                otherdata_names <- names(other_data)
            }

        }
        if(!is.null(other_data)){
            if(length(other_tss_distance) != length(other_data)){
                other_tss_distance <- rep(other_tss_distance[1],
                                          length(other_data))
            }
            if(is.null(names(other_tss_distance))){
            names(other_tss_distance) <- otherdata_names
            }
        }

        tss <- GenomicRanges::shift(GenomicRanges::flank(data_grange, width=2), 1)
        tss$feature <- "tss"

        if(!is.null(other_data)){
            other <- do.call(c, sapply(1:length(other_data), function(i){

                if(!inherits(other_data[[i]], "GRanges")){
                temp_other<-c(GenomicRanges::GRanges(
                    seqnames=other_data[[i]][, 1],
                    ranges=IRanges::IRanges(start=other_data[[i]][, 2],
                                   end=other_data[[i]][, 3])))
                }
                else {
                temp_other <- other_data[[i]]
                GenomicRanges::mcols(temp_other) <- NULL
                }
                temp_other <- unique(temp_other)


                suppressWarnings(
                    overlap <- findOverlaps(GenomicRanges::flank(data_grange,
                                                 other_tss_distance[otherdata_names[i]],
                                                 start=TRUE), temp_other)
                )
                temp_other <- temp_other[as.numeric(S4Vectors::subjectHits(overlap))]
                temp_other$name <-
                    data_grange$name[S4Vectors::queryHits(overlap)]
                temp_other$feature <- otherdata_names[i]
                temp_other
            })
            )
        }
        promoters_downstream <- GenomicRanges::flank(data_grange, -promoter_downstream_distance,
                                    start=TRUE)
        promoters_upstream <- GenomicRanges::flank(data_grange, 
            promoter_upstream_distance, start=TRUE)
        end(promoters_upstream) <- end(promoters_upstream)+1

        promoters <- GenomicRanges::punion(promoters_upstream, promoters_downstream)
        promoters$name <- data_grange$name
        promoters$feature <- "promoter"

        body <- GenomicRanges::psetdiff(data_grange, promoters_downstream)
        body$name <- data_grange$name
        body$feature <- "body"


        if(!is.null(other_data)){
            suppressWarnings(combined_data <-
                                 c(data_grange, promoters, body, other, tss))
        }
        else{
            suppressWarnings(combined_data <-
                                 c(data_grange, promoters, body, tss))
        }
        combined_data <- split(combined_data, combined_data$name)
        slot(combined_data, "metadata")$params <-
            c(
                promoter_upstream_distance_tss=promoter_upstream_distance,
                promoter_downstream_distance_tss=promoter_downstream_distance,
                other_annotation_distance_tss=other_tss_distance
            )
        slot(combined_data, "metadata")$sizes_summary <- lapply(
            split(unlist(combined_data), unlist(combined_data)$feature),
            function(i){each_length <- width(i);
                        c(summary(each_length), sds=sd(each_length))
            })
        new("PvalueAnnotation", annotation=combined_data)
    })


##Convert ids between types refseq, ensembleprot and uniprot to gene symbol

setMethod(
    f="convertGeneIds",
    signature(gene_IDs="character", ID_type="character", ID_convert_to="character"),
    definition=function(gene_IDs, ID_type, ID_convert_to, delim=NULL, verbose=FALSE)
    {
        if(any(duplicated(gene_IDs))){stop(
            "Cannot convert duplicated ids. Please remove duplicates.")
        }

        if(!is.null(delim)){
            gene_IDs <- do.call(rbind, strsplit(gene_IDs, delim))[, 2]
        }

        genes_old <- unique(as.character(gene_IDs))
        gene_IDs <- cbind(gene_IDs, 1:length(gene_IDs))

        if(ID_type == "refseq"){
            genes_old <- subset(genes_old, genes_old %in%
                                    (AnnotationDbi::ls(org.Hs.eg.db::org.Hs.egREFSEQ2EG)))

            if(ID_convert_to == "symbol"){

                eg <- unlist(AnnotationDbi::mget(genes_old,
                                                 org.Hs.eg.db::org.Hs.egREFSEQ2EG))
                symbol <- unlist(AnnotationDbi::mget(eg,
                                                     org.Hs.eg.db::org.Hs.egSYMBOL))
                out <- cbind(names(eg), symbol)
            }
        }

        else
            if(ID_type == "ensembleprot"){
                genes_old <- subset(genes_old, genes_old %in%
                            (AnnotationDbi::ls(org.Hs.eg.db::org.Hs.egENSEMBLPROT2EG)))

                if(ID_convert_to == "symbol"){
                    eg <- unlist(AnnotationDbi::mget(genes_old,
                                                     org.Hs.eg.db::org.Hs.egREFSEQ2EG))
                    symbol <- unlist(AnnotationDbi::mget(eg,
                                                         org.Hs.eg.db::org.Hs.egSYMBOL))
                    out <- cbind(names(eg), symbol)
                }
            }
        else
            if(ID_type == "uniprot"){
                genes_old <- subset(genes_old, genes_old %in%
                                        (AnnotationDbi::ls(org.Hs.eg.db::org.Hs.egUNIPROT)))

                if(ID_convert_to == "symbol"){
                    eg <- unlist(AnnotationDbi::mget(genes_old,
                                                     org.Hs.eg.db::org.Hs.egREFSEQ2EG))
                    symbol <- unlist(AnnotationDbi::mget(eg,
                                                         org.Hs.eg.db::org.Hs.egSYMBOL))
                    out <- cbind(names(eg), symbol)
                }
            }
        else
            if(ID_type == "ensemble"){
                genes_old <- subset(genes_old, genes_old %in%
                                        (AnnotationDbi::ls(org.Hs.eg.db::org.Hs.egENSEMBL2EG)))
                if(ID_convert_to == "symbol"){
                    eg <- unlist(AnnotationDbi::mget(genes_old,
                                                     org.Hs.eg.db::org.Hs.egENSEMBL2EG))
                    symbol <- unlist(AnnotationDbi::mget(eg,
                                                         org.Hs.eg.db::org.Hs.egSYMBOL))
                    out <- cbind(names(eg), symbol)
                }
            }
        else
            if(ID_type == "entrez"){
                if(ID_convert_to == "symbol"){

                    symbol <- unlist(AnnotationDbi::mget(genes_old,
                                                         org.Hs.eg.db::org.Hs.egSYMBOL))
                    out <- cbind(names(symbol), symbol)
                }
            }
        else
            if(ID_type == "symbol"){
                genes_old <- subset(genes_old, genes_old %in%
                                        (AnnotationDbi::ls(org.Hs.eg.db::org.Hs.egALIAS2EG)))
                if(ID_convert_to == "entrez"){
                    eg <- unlist(AnnotationDbi::mget(genes_old,
                                                     org.Hs.eg.db::org.Hs.egALIAS2EG))
                    out <- cbind(names(eg), eg)
                }

            }

        out <- merge(gene_IDs, out, by=1, all.x=TRUE)
        out <- out[order(as.numeric(out[, 2])), ]
        out <- subset(out,!duplicated(out[,1]))

        out[, 3]
    })

setMethod(
    f="annotateExpression",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, expr_data, effect_col=NULL, pval_col=NULL){
        if(is.null(effect_col)){
            effect_col=grep("effect|odds|coeff|B", tolower(colnames(expr_data)))
            if(length(effect_col) != 1){
                stop("Cannot determine effect column. Please specify with arg:effect_col")
            }
        }

        if(any(!c(-1,1) %in% unique(sign(expr_data[, effect_col])))){
            message("WARNING: Effects should provide a direction, but these effects
            are all in the same direction.")
        }

        if(is.null(pval_col)){

            pval_col <- grep("pval|p.val|p_val|sig", tolower(colnames(expr_data)))
            if(length(effect_col) != 1){
                stop("Cannot determine p.value column. Please specify with arg:effect_col")
            }
        }
        if(any(expr_data[, pval_col] < 0, expr_data[, pval_col] > 1)){
            stop("P-values must be between 0 and 1")
        }
        temp_pval_col <- expr_data[, pval_col]
        temp_pval_col <- replace(temp_pval_col, temp_pval_col < .0000001,.0000001)
        temp_pval_col <- replace(temp_pval_col, temp_pval_col > .9999999,.9999999)
        expr_data[, pval_col] <- temp_pval_col

        expression_output <- ExpressionSet(as.matrix(expr_data), featureNames=rownames(expr_data))
        phenoData(expression_output) <-
            new("AnnotatedDataFrame",
                data=as.data.frame(exprs(expression_output)[,
                                                            c(effect_col, pval_col)]))
        varLabels(expression_output) <- c("expression_effect",
                                                      "expression_pvalue")
        slot(pvalue_annotation, "expression") <- expression_output
        pvalue_annotation
        })



setMethod(
    f="annotateModification",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, mod_data, weight_by=NULL,
                        weight_by_method="Stouffer", mod_included=NULL,
                        mod_corr=TRUE, mod_type="methylation", verbose=FALSE){
        if(mod_type %in% names(slot(slot(pvalue_annotation,"modifications"),"metadata")$elements))
        {
            stop("Provided data set is already loaded as mod_type")
        }
        
        unique_feature_names <- unique(
            unlist(slot(pvalue_annotation, "annotation"))$feature)
        
        ##no weights provided
        if(missing(weight_by)){
            weight_by <- rep("pval", length(unique_feature_names[!unique_feature_names %in%
                                                                     c("original", "tss")]))
        }
        ##no mod_included or weight names
        if(is.null(names(weight_by))){
            if(is.null(mod_included)){
                mod_included <- unique_feature_names[!unique_feature_names %in%
                                                         c("original", "tss")]
            }
            names(weight_by) <- mod_included
        }
        
        ##weight names were provided
        if(!is.null(names(weight_by))){
            mod_included <- names(weight_by)
            if(!all(mod_included %in% unique_feature_names)){
                stop("Provided weight names must match those in
                     unique(GenomicRanges::mcols(unlist(pvalue_annotation@annotation))$feature)")
            }
            }
        
        if(any(!c(-1, 1) %in% unique(sign(mod_data[, 4])))){
            message("WARNING: Effects should provide a direction,
                    but these effects are all in the same direction.")
        }
        
        if(any(mod_data[, 5] < 0,mod_data[, 5] > 1)){
            stop("P-values must be between 0 and 1")
        }
        
        
        mod_grange <- GenomicRanges::GRanges(seqnames=mod_data[, 1],
                                             ranges=IRanges::IRanges(start=mod_data[, 2], end=mod_data[, 3]),
                                             effect=mod_data[, 4], pval=mod_data[, 5], type=mod_type)
        
        temp_annotation <- unlist(slot(pvalue_annotation, "annotation"))
        
        overlap_mods <- GenomicRanges::findOverlaps(temp_annotation, mod_grange)
        mod_grange_overlaps <- mod_grange[S4Vectors::subjectHits(overlap_mods)]
        GenomicRanges::mcols(mod_grange_overlaps) <- cbind(GenomicRanges::mcols(
            temp_annotation[as.numeric(
                S4Vectors::queryHits(overlap_mods))]),
            GenomicRanges::mcols(mod_grange_overlaps))
        mod_grange_overlaps <- split(mod_grange_overlaps, mod_grange_overlaps$name)
        temp_annotation <- split(temp_annotation, temp_annotation$name)
        
        if(mod_corr == TRUE){
            if(verbose == TRUE){
                message("Computing correlation matrices")
            }
            temp_split_mod_grange <- split(mod_grange, GenomicRanges::seqnames(mod_grange))
            precede_follow_each_element <- lapply(temp_split_mod_grange,
                                                  function(chr){
                                                      temp_chr <- IRanges(start(chr), end(chr))
                                                      temp_precede <- precede(temp_chr)
                                                      temp_follow <- follow(temp_chr)
                                                      temp_precede[which(is.na(temp_precede))] <-
                                                          which(is.na(temp_precede))
                                                      temp_follow[which(is.na(temp_follow))] <-
                                                          which(is.na(temp_follow))
                                                      chr[c(temp_follow, temp_precede)]
                                                  })
            mod_grange_corr <- unlist(GRangesList(precede_follow_each_element))
            
            duplicate_each_chr <- lapply(temp_split_mod_grange, function(chr){
                c(chr,chr)
            })
            duplicate_each_chr <- unlist(GRangesList(duplicate_each_chr))
            mod_grange_corr$distance <- IRanges::distance(duplicate_each_chr,
                                                          mod_grange_corr)
            
            mod_grange_corr$pval2 <- duplicate_each_chr$pval
            mod_grange_corr <- mod_grange_corr[which(mod_grange_corr$pval2<0.05)]
            quantile_distances_mod_corr <- Hmisc::cut2(mod_grange_corr$distance,
                                                       g=500, onlycuts=TRUE)
            quantile_distances_mod_corr[length(quantile_distances_mod_corr)] <- 250000000
            mod_grange_corr$cat <- cut(mod_grange_corr$distance, breaks=quantile_distances_mod_corr)
            mod_grange_corr <- split(mod_grange_corr, mod_grange_corr$cat)
            mod_grange_corr2 <- lapply(mod_grange_corr, function(j){
                mean((sapply(1:500, function(i){
                    index <- sample(1:length(j), replace=TRUE);
                    cor(qnorm(1-j$pval[index]), qnorm(1-j$pval2[index]))
                })))
            })
            correlations <- as.data.frame(do.call(rbind, mod_grange_corr2))
            final_corr <- data.frame(correlations,
                                     as.character(names(mod_grange_corr2)),
                                     stringsAsFactors=FALSE)
            final_corr <- rbind(c(.9, paste("(-1, ", quantile_distances_mod_corr[1], "]",
                                            sep="")), final_corr)
            rm(mod_grange_corr)
        }
        combined_pvalues_list <- sapply(mod_included, function(i){
            if(verbose == TRUE){
                message(paste("Combining p-values over:", i))
            }
            temp <- subset(unlist(mod_grange_overlaps), unlist(mod_grange_overlaps)$feature == i)
            
            
            ref_data <- unlist(slot(pvalue_annotation, "annotation"))
            ref_data <-
                subset(ref_data,
                       ref_data$feature == "tss")
            ref_data <- ref_data[temp$name]
            suppressWarnings(temp$distance <- distance(ref_data,
                                                       temp)+2)
            temp <- split(temp, temp$name)
            forreturn <- lapply(temp, function(each){
                each_length <- length(each)
                each_effect <- each$effect[order(each$pval)]
                each_pval <- each$pval[order(each$pval)]
                distances <- each$distance[order(each$pval)]
                if(length(each_pval > 1)){
                    if(mod_corr == TRUE){
                        corr_mat <- matrix(as.numeric(final_corr[match(cut(
                            as.matrix(dist(start(each)[order(each$pval)])),
                            breaks=c(-1, quantile_distances_mod_corr)), final_corr[, 2]), 1]),
                            ncol=each_length)
                        diag(corr_mat) <- 1
                        corr_mat<-abs(corr_mat)
                        chol_d <- try(chol(corr_mat), silent=TRUE)
                        while(is(chol_d, "try-error"))
                        {
                            index<- as.numeric(strsplit(
                                strsplit(chol_d[1],
                                         "the leading minor of order ")[[1]][2],
                                " is not positive")[[1]][1])-1
                            chol_d <- try(chol(corr_mat[1:index, 1:index]),silent=TRUE)
                            each_pval <- each_pval[1:index]
                            each_effect <- each_effect[1:index]
                            distances <- distances[1:index]
                            each_length <- index
                        }
                        
                        each_pval <- 1-pnorm(abs(solve(t(chol_d)) %*% qnorm(
                            1-each_pval/2)))
                        each_pval<-replace(each_pval, each_pval == 0 , 0.000000001)
                        each_pval <- each_pval*2
                    }
                    
                    if(weight_by_method == "Stouffer"){
                        
                        if(weight_by[i] == "distance"){
                            ##mean is weighted by distance
                            out_mean <- weighted.mean(each_effect,
                                                      w=(1/log(distances)))
                            ##Stouffer test is weighted by distance
                            out_pval <- stoufferTest(each_pval, weights=(1/log(distances)))
                        }
                        else if(weight_by[i] %in%
                                c("pval", "p.value", "pvalue", "p_val")){
                            ##mean is weight by pvalue
                            out_mean <- weighted.mean(each_effect, w=-log(each_pval))
                            out_pval <- stoufferTest(each_pval, weights=NULL)
                        }
                        else {
                            ##mean is not weighted
                            out_mean <- mean(each_effect, na.rm=TRUE)
                            out_pval <- stoufferTest(each_pval, weights=NULL)
                        }
                        
                    }
                    else if(weight_by_method %in% c("minimum", "Sidak", "sidak")){
                        
                        index <- which(each_pval == min(each_pval))
                        if(length(index) > 1){
                            index <- index[which(
                                abs(each_effect[index]) == max(abs(each_effect[index])))][1]
                        }
                        out_mean <- each_effect[index]
                        out_pval <- 1-(1-each_pval[index])^length(each_pval)
                        
                    }
                    else if(weight_by_method == "binomial"){
                        
                        index <- which(each_pval == min(each_pval))
                        if(length(index) > 1){
                            index <- index[which(abs(each_effect[index]) == max(
                                abs(each_effect[index])))][1]
                        }
                        out_mean <- each_effect[index]
                        out_pval <- (1-pbinom(q=length(which(each_pval<0.05)),
                                              size=each_length, prob=0.05))
                    } else if(weight_by_method %in%
                              c("Fisher", "fisher", "chisq", "chi")){
                        out_pval <- 1-pchisq(-2*sum(log(each_pval)), each_length*2)
                        out_mean <- mean(sign(each_effect), na.rm=TRUE)
                        
                    }
                }
                #if only one pval
                else{
                    out_mean <- each_effect
                    out_pval <- each_pval
                }
                
                c(out_mean, out_pval, each_length)
            })
            
            do.call(rbind, forreturn)
        })
        
      if(verbose == TRUE){
            message("Quantile permuting scores")
        }
        combined_pvalues_list <- lapply(combined_pvalues_list, function(each_feature){
            categories <- data.frame(categories=as.numeric(
                Hmisc::cut2(each_feature[, 3], g=100)))
            categories_table <- data.frame(table(categories))
            
            trans_p <- cbind(trans=qnorm(1-each_feature[, 2]/2),
                             plyr::join(categories, categories_table, by="categories"))

            trans_p[, 1] <- replace(trans_p[, 1],is.infinite(trans_p[, 1]),
                                    max(subset(trans_p, !is.infinite(
                                        trans_p[, 1])), na.rm=TRUE))

            num_list <- split(trans_p$trans, trans_p$categories)
            rand_list <- sapply(1:length(num_list), function(i){
                as.matrix(sapply(1:500, function(j){
                    sample(num_list[[as.numeric(i)]], replace=TRUE)
                }))
            })
            new_pval <- apply(trans_p, 1, function(i){
                length(which(
                    rand_list[[as.numeric(i[2])]] > as.numeric(i[1])))/
                    (500*as.numeric(i[3]))
            })
            new_pval <- replace(new_pval, new_pval == 0,
                                min(subset(new_pval, new_pval != 0),
                                    na.rm=TRUE))

            each_feature[, 2] <- new_pval
            each_feature <- as.data.frame(each_feature)
            each_feature
        })
        
        if(verbose == TRUE){
            message("Scores have been adjusted")
        }
        
        newmods <- c(unlist(slot(pvalue_annotation, "modifications")),
                     unlist(mod_grange_overlaps))
        names(newmods) <- NULL
        newmods <- split(newmods, newmods$name)
        
        output_m_summary <-
            suppressWarnings(as.data.frame(c(list(names=names(mod_grange_overlaps)),
                                             lapply(combined_pvalues_list, function(x){
                                                 x[match(names(
                                                     mod_grange_overlaps),
                                                     rownames(x)), 1:2]
                                             }))))
        rownames(output_m_summary) <- output_m_summary[, 1]
        output_m_summary <- output_m_summary[, -1]
        colnames(output_m_summary) <- paste(mod_type,
                                            apply(expand.grid(c("effect", "pvalue"),
                                                              mod_included),1, function(i){
                                                                  paste(i[2], i[1],
                                                                        sep="_")
                                                              }), sep="_")
        
        newmetadata <- slot(slot(pvalue_annotation, "modifications"), "metadata")
        if(is.null(newmetadata$m_summary)){
            newmetadata$m_summary <- output_m_summary
        }
        else{
            newmetadata$m_summary <- merge(newmetadata$m_summary,
                                           output_m_summary, by=0, all=TRUE)
            rownames(newmetadata$m_summary) <- newmetadata$m_summary[, 1]
            newmetadata$m_summary <- newmetadata$m_summary[, -1]
        }
        newmetadata[["elements"]][[mod_type]]$weight_by <- weight_by
        newmetadata[["elements"]][[mod_type]]$weight_by_method <- weight_by_method
        newmetadata$elementnames <- c(newmetadata$elementnames,
                                      paste(mod_type, mod_included, sep="_"))
        
        slot(newmods, "metadata") <- newmetadata
        slot(pvalue_annotation, "modifications") <- newmods
        pvalue_annotation
        }
)

setMethod(
    f="removeModification",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, mod_type="methylation"){

        if(!mod_type%in%names(slot(pvalue_annotation,
                                  "modifications")@metadata$elements)){
            stop("Provided mod_type is not in the pvalue_annotation")
        }

        temp_meta <- slot(slot(pvalue_annotation,"modifications"),"metadata")
        temp <- unlist(slot(pvalue_annotation,"modifications"))
        names(temp) <- NULL
        temp <- subset(temp,!(temp$type == mod_type))
        slot(temp,"metadata") <- temp_meta
        temp_meta_colnams <- colnames(slot(temp,"metadata")$m_summary)
        slot(temp,"metadata")$m_summary <-
            slot(temp,"metadata")$m_summary[, -grep(mod_type, temp_meta_colnams)]

        if(ncol(slot(temp,"metadata")$m_summary) == 0){
            slot(temp,"metadata")$m_summary <- NULL
        }

        slot(temp,"metadata")$elements[which(
            names(slot(temp,"metadata")$elements) == mod_type)] <- NULL


        slot(temp,"metadata")$elementnames <-
            slot(temp,"metadata")$elementnames[
                -which(do.call(rbind, lapply(strsplit(
                    slot(temp,"metadata")$elementnames, "_"),
                    function(i)i[1]))[, 1] %in% mod_type)]

        temp_meta <- slot(temp,"metadata")
        slot(pvalue_annotation,"modifications") <- split(temp, temp$name)
        slot(slot(pvalue_annotation,"modifications"),"metadata") <- temp_meta
        pvalue_annotation
    }
)

setMethod(
    f="makePvalueObject",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, effect_directions=NULL) {


        if(is.null(effect_directions)){
            effect_directions <- rep("bidirectional",
                                     length(slot(
                                                slot(pvalue_annotation, "modifications"),
                                                "metadata")$elementnames))
        }

        if(is.null(names(effect_directions))){
            names(effect_directions)<-slot(slot(pvalue_annotation, "modifications"),
                                           "metadata")$elementnames
        }

        if(any(!names(effect_directions) %in% slot(slot(pvalue_annotation, "modifications"),
                                                 "metadata")$elementnames)){
            stop("Effect name is invalid")
        }

        if(any(!(effect_directions %in% c("decrease", "increase", "bidirectional")
        ))){
            stop("Effect argument is invalid.")
        }


        exp_ind <- ifelse(nrow(Biobase::pData(pvalue_annotation@expression)) >
                              0, 1, 0)

        total_num_factor <- length(effect_directions)

        signs_index <- merge(cbind(c("increase", "decrease", "bidirectional"),
                                c(1, -1, 2)),
                          cbind(effect_directions, 1:total_num_factor), by=1)
        signs_index <- signs_index[order(signs_index[, 3]), ]
        rownames(signs_index) <- NULL
        colnames(signs_index) <- c("expression_relationship", "B_coeff","name")

        temp1 <- annotationOutput(pvalue_annotation)
        genenames <- temp1[, 1]
        data <- temp1[, -1]

        if(exp_ind == 1){
            data <- data[, c(as.numeric(sapply(names(effect_directions),
                                             function(i){
                                                 grep(i, colnames(data))
                                             })),
                            grep("exp", colnames(data)))]

        }
        else {
            data <- data[, as.numeric(sapply(names(effect_directions),
                                             function(i){
                                                 grep(i, colnames(data))
                                             }))]
        }
        signs_index[, 3] <- names(effect_directions)
        slot(pvalue_annotation, "score_data") <- new(Class="PvalueObject",
                                        pval_data=data[, grep("pval",
                                                              colnames(data))],
                                        effect_data=data[, grep("effect",
                                                                colnames(data))],
                                        genes=genenames,
                                        signs_index=signs_index)
        pvalue_annotation
    }
)




setMethod(
    f="normalizePval",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, trans, ref="expression_pvalue",
                        method="rescale"){

        temp_pval_data <- slot(slot(pvalue_annotation,"score_data"),"pval_data")

        names_temp_pval_data <- colnames(temp_pval_data)

        if(nrow(temp_pval_data) == 0){
            stop("Run makePvalueObject function first.")
        }
        if(!any(grepl(ref,names_temp_pval_data))){
               stop("paste(Reference is not one of the available:",
                    names_temp_pval_data)
        }
        if(length(grep(ref,names_temp_pval_data)) > 1){
               stop("Reference was not specific enough.")
        }

        ref_index <- grep(ref,names_temp_pval_data)
        p_ref <- temp_pval_data[[ref_index]]
        logit_ref <- log(p_ref/(1-p_ref))
        temp_signs_index<-slot(slot(pvalue_annotation,"score_data"),
                               "signs_index")[, 3]

        if(!names(dev.cur()) %in% c("RStudioGD","pdf")){
            dev.new(height=7, width=14)
        }

        par(mfrow=c(1, 2))
        plotDensityPval(pvalue_annotation, ref=ref)

        if(method %in% c("Box-Cox", "box-cox", "boxcox", "Boxcox")){
            if(missing(trans)){
                message(paste("Auto-detecting best transformation"))
                optimal_boxcox_exponent <- c()
                for(x in names_temp_pval_data[-ref_index]){

                    p_temp <- temp_pval_data[[x]]
                    if(!all(is.na(p_temp))){
                        logit_temp <- log(p_temp/(1-p_temp))
                        nonparametric_comparison <- t(sapply(c(seq(.05, .95, .05),
                                           rev(1/seq(.05, .95, .05))),
                                           function(i){
                                               c(i,wilcox.test(logit_ref,
                                                        as.numeric(logit_temp)*i)$p_value)
                                               }))
                        nonparametric_comparison <-  subset(nonparametric_comparison, 
                        nonparametric_comparison[, 2] == max( 
                        nonparametric_comparison[, 2])[1])[, 1]
                        p_temp <-
                               (exp(logit_temp)^( nonparametric_comparison))/(1+exp(logit_temp)^( nonparametric_comparison))
                    }
                    else {
                        nonparametric_comparison <- 1
                    }
                       optimal_boxcox_exponent <- c(optimal_boxcox_exponent,  nonparametric_comparison)
                       names(optimal_boxcox_exponent)[length(optimal_boxcox_exponent)] <- x
                       temp_pval_data[[x]] <- p_temp

                }
            }

            else {



                if(length(trans) !=
                       length(grep(paste(temp_signs_index, collapse="|"),
                                   colnames(temp_pval_data)))){
                       stop("Length of p and transformations must equal!")
                }
                else {
                    optimal_boxcox_exponent <- trans
                    names(optimal_boxcox_exponent) <- subset(names_temp_pval_data,
                                                             !names_temp_pval_data %in% ref)
                }
                for(x in names(optimal_boxcox_exponent)){
                    p_temp <- temp_pval_data[[x]]
                    if(!all(is.na(p_temp))){
                           p_temp <- p_temp^optimal_boxcox_exponent[x]
                    }
                    temp_pval_data[[x]] <- p_temp
                }
            }
        }
        else if(method%in%c("Rescale", "rescale")){
            for(i in temp_signs_index){
                if(!all(is.na(slot(
                    slot(pvalue_annotation, "score_data"), "pval_data")[[grep(i,
                                                                   names_temp_pval_data)]])
                   )){
                    p_temp <- temp_pval_data[[grep(i, names_temp_pval_data)]]
                    logit_temp <- log(p_temp/(1-p_temp))
                    logit_temp <- scales::rescale(logit_temp, to=range(logit_ref,
                                                                    na.rm=TRUE))
                    temp_pval_data[[grep(i,
                                           names_temp_pval_data
                                           )]] <- exp(logit_temp)/(1+exp(logit_temp))
                }
            }
        }

        slot(slot(pvalue_annotation,"score_data"),"pval_data") <- temp_pval_data
        plotDensityPval(pvalue_annotation, ref=ref)
        pvalue_annotation
    }
)

setMethod(
    f="scorePval",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, weights){

        total_num_factor <- ncol(slot(slot(pvalue_annotation, "score_data"), "pval_data"))
        pval_score_colnames <- colnames(slot(slot(pvalue_annotation,"score_data"),
                                             "pval_data"))
        if(missing(weights)){
            weights <- rep((1/(total_num_factor)), total_num_factor)
            names(weights) <- pval_score_colnames
        }
        else {
            if(length(weights) != total_num_factor){
                stop("ERROR: Number of factors(with expression data)
                     and weights must equal!")
            }
            else {

                if(is.null(names(weights))){
                    names(weights) <- pval_score_colnames
                }
                sorted_pval_score_colnames <- sort(do.call(rbind, strsplit(pval_score_colnames,
                                             "_pvalue")))
                if(!all(sort(names(weights)) == sorted_pval_score_colnames))
                {
                    stop(paste("Weight names must match the following:",
                               paste(sorted_pval_score_colnames,
                                     collapse=", ")))
                }
            }
        }

        weights <- weights[match(
            do.call(rbind, strsplit(pval_score_colnames, "_pvalue")),
            names(weights))]

        message("The following weights are being applied")
        print(weights)
        temp_score_data <- slot(pvalue_annotation, "score_data")
        temp_pval_data <- slot(temp_score_data, "pval_data")
        temp_effect_data <- slot(temp_score_data, "effect_data")
        temp_signs_index <- slot(temp_score_data, "signs_index")
        scoringdata <- temp_pval_data*sign(temp_effect_data)

        weight_names_temp <- names(weights)

        if(any(grepl("exp", names(weights)))){
            weight_names_temp <- weight_names_temp[-grep("exp", names(weights))]
        }
        slot(temp_score_data, "scoring_vector") <- weights

        unidirectional <- as.numeric(temp_signs_index[match(temp_signs_index[, 3], weight_names_temp), 2])
        bidirectional <- unidirectional
        unidirectional[which(unidirectional == 2)] <- 0
        bidirectional[which(bidirectional != 2)] <- 0
        bidirectional[which(bidirectional == 2)] <- 1


        scoringdata <- qnorm(1-as.matrix(abs(scoringdata))/2)*sign(scoringdata)
        scoresout <- apply(scoringdata, 1, function(each){
            # for each gene
            if(any(!is.na(each)))
            {
              # not all missing
                if(any(grepl("exp", names(each)))){
                    # there is expression data
                    exp_index <- grep("exp", names(each))
                    forreturn <- (sum(
                        abs(sum(c(as.numeric(each[[exp_index]]),
                                  as.numeric(each[-exp_index]))*
                                    c(1, unidirectional)*
                                    weights[c(exp_index, 
                                              which(!grepl("exp", names(each))))],
                                na.rm=TRUE)),
                        (abs(as.numeric(each[-exp_index])*bidirectional)*
                             weights[-exp_index]),
                        na.rm=TRUE)/sum(weights^2)^.5)
                }
                else {

                    # there is no expression data

                    forreturn <- (
                        sum(abs(sum(as.numeric(each)*unidirectional*weights,
                                    na.rm=TRUE)), (abs(as.numeric(each)*
                                                           bidirectional)*
                                                       weights),
                            na.rm=TRUE)/sum(weights^2)^.5)
                }
            }
            else {
                forreturn <- (NA)
            }
            forreturn
        })

        scoresout <- (1-pnorm(as.numeric(scoresout)))*2
        iscoresout<-replace(scoresout, scoresout == 0 ,  min(subset(scoresout,
                 !(scoresout == 0)), na.rm=TRUE))
                scoresout <- (-2*log(scoresout))
        rand_mat <- as.matrix(sapply(1:100, function(j){
            sample(scoresout, replace=TRUE)
            }))
        new_pval <- sapply(scoresout , function(i){
            length(which(rand_mat > as.numeric(i)))/(100*length(scoresout))
        })
        new_pval <- replace(new_pval, new_pval == 0,
                            min(subset(new_pval, new_pval!=0), na.rm=TRUE))
        new_pval <- (-2)*log(new_pval)



        slot(temp_score_data, "scores") <-
            data.frame(scores=as.numeric(new_pval),
                       row.names=as.character(slot(temp_score_data,
                                                   "genes")))
        slot(pvalue_annotation, "score_data") <- temp_score_data
    pvalue_annotation
    }
)

setMethod(
    f="runSpinglass",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, network, random_alpha = 0.05, gam = 0.5,
                        node_alpha = 0.05, maxsize = 500, minsize = 8,
                        num_iterations = 1000, simplify=TRUE)
    {

        if(inherits(network, what="graphNEL")){
            network <- igraph.from.graphNEL(network)
        }

        if(length(slot(slot(pvalue_annotation,"score_data"),"module_output")) !=0 ){
            slot(slot(pvalue_annotation,"score_data"),"module_output") <- list()
            message("Overwriting existing modules.")
        }

        if(simplify == TRUE){
            network <- igraph::simplify(network, remove.multiple=TRUE,
                                        remove.loops=TRUE)
        }
        genes_in_network <- subset(slot(slot(pvalue_annotation, "score_data"),
                                        "genes"),
                                   slot(slot(pvalue_annotation, "score_data"),
                                        "genes") %in%
                                       igraph::V(network)$name)
        scores_in_network <- extractScores(pvalue_annotation)[genes_in_network]

        ##should be FALSE, but just in case check for NAs
        if(any(is.na(scores_in_network))){
            ##if there are NAs remove them
            scores_in_network <- subset(scores_in_network, !is.na(
                scores_in_network))
            genes_in_network <- names(scores_in_network)
        }

        nodes_with_scores <- base::intersect(genes_in_network, igraph::V(network)$name) 
        network <- igraph::induced_subgraph(network, nodes_with_scores)
        network_clusters <- igraph::clusters(network)

        ## choose largest connected nodes ## may want include > minsize
        maxclust <- which(network_clusters$csize ==
                              max(network_clusters$csize))[1]
        network <- igraph::induced_subgraph(network,
                                    which(network_clusters$membership == maxclust))
        rm(network_clusters)
        genes_in_network <- intersect(genes_in_network, igraph::V(network)$name) 
        
        scores_in_network <- scores_in_network[genes_in_network]
        network.adj <- igraph::as_adjacency_matrix(network)

        ## order of scores has to match order of adjacency rows
        scores_in_network <- scores_in_network[rownames(network.adj)]
        genes_in_network <- names(scores_in_network)
        stat_scores <- as.numeric(scores_in_network)
        pval_scores <- exp(scores_in_network/(-2))

        network_with_scores <- apply(network.adj, 1, function(v) v*stat_scores)
        W_for_spinglass <- (network_with_scores + t(network_with_scores))
        rm(network_with_scores)
        gc()
        W_vec <- (-2*log(1-pchisq(as.vector(W_for_spinglass),4)))

        W_vec <- replace(W_vec, is.infinite(W_vec),
                         max(subset(W_vec, !is.infinite(W_vec))) )

        W_for_spinglass <- matrix(W_vec, nrow=nrow(W_for_spinglass))
        rm(W_vec)
        rownames(W_for_spinglass) <- genes_in_network
        colnames(W_for_spinglass) <- genes_in_network
        gc()
        final_network <-
            igraph::graph_from_adjacency_matrix(W_for_spinglass,
                                                mode = "undirected",
                                                weighted=TRUE)
        igraph::V(final_network)$weight <- stat_scores
        network <- final_network
        rm(final_network)
        gc()

        ## For significant genes apply Spinglass algorithm
        sig_genes <- subset(genes_in_network, pval_scores < node_alpha)
        sig_genes_counter <- 1:length(sig_genes)
        names(sig_genes_counter) <- sig_genes
        spin_glass_out <- lapply(sig_genes, function(j){
            message(paste("Computing modules: Vertex",sig_genes_counter[j],"of",
                          length(sig_genes), "significant genes is", j))
            genes_in_network[
                cluster_spinglass(network, weights = igraph::E(network)$weight,
                                  vertex=j, gamma=gam)$community]
            })
        names(spin_glass_out) <- sig_genes

        ## Select modules with size requirements
        spin.size <- do.call(c, lapply(spin_glass_out, length))
        spin_glass_out <- subset(spin_glass_out, spin.size >= minsize & spin.size
                                <= maxsize)

        Modularity.edges = function(v, network)
        {
            h <- igraph::induced_subgraph(network, v);
            c(sum(igraph::E(h)$weight))
        }
        edge_sum <- do.call(c,lapply(spin_glass_out, function(j) {
            Modularity.edges(j, network)
        }));

        nspin_glass_out <- length(spin_glass_out);
        random_edges <- lapply(1:nspin_glass_out, function(i) {
            each_spin_result <- spin_glass_out[[i]]
            subnetwork <- igraph::induced_subgraph(network, each_spin_result);
            adjacency_of_subnetwork <- igraph::as_adjacency_matrix(subnetwork, sparse=FALSE);
            sapply(1:num_iterations, function(k){
                message(paste("Testing significance: module", i, "of",
                              nspin_glass_out, "Randomization", k, "of", num_iterations))
                random_sample_of_scores = sample(stat_scores, nrow(adjacency_of_subnetwork) , replace=TRUE)
                random_network_with_scores = apply(adjacency_of_subnetwork, 1, function(v) v*random_sample_of_scores)
                W_random <- (random_network_with_scores + t(random_network_with_scores));
                W_random <- apply(W_random, 2, function(i){
                    replace(i, i>0, (-2*log(1-pchisq(subset(i,i>0),4))))
                    })
                sum(W_random)/2
            })
        })
        names(random_edges) <- names(spin_glass_out);

        random_p <- lapply(1:nspin_glass_out, function(k){
            length(which(random_edges[[k]] >
                             edge_sum[k]))/num_iterations})
        names(random_p) <- names(spin_glass_out)

        if(length(spin_glass_out[which(do.call(c,random_p) < random_alpha)]) == 0){
            stop("No modules found.  Please adjust the random_alpha and node_alpha
                 parameters")
        }

        ## Assemble output data
        output <- list();
        output[[1]] <- subset(spin_glass_out, do.call(c,random_p) < random_alpha);
        output[[2]] <- pval_scores;
        output[[3]] <- stat_scores;
        output[[4]] <- igraph::induced_subgraph(network, as.character(
            unlist(output[[1]]))) ;
        output[[6]] <- "spinglass";


        names(output) <- c("modules",  "p_value",
                          "statistic","network","moduleStats","moduleType");
        k <- 1
        while(k < length(output[[1]])){
            m <- k+1
            while(m <= length(output[[1]])){
                if(all(output[[1]][[m]] %in% output[[1]][[k]])){
                    names(output[[1]])[k] <- paste(names(output[[1]][k]),
                                                   names(output[[1]][m]),
                                                   sep=":")
                    output[[1]][[m]]<-NULL
                    m <- m-1
                }
                m <- m+1
            }
            k <- k+1
        }
        output[[5]] <-
            lapply(output[[1]], function(i){
                stat.mod <- sum(abs(subset(stat_scores,genes_in_network %in% i)))
                pval.mod <- 1-pchisq(stat.mod,2*length(i))
                c(statMod=stat.mod, pvalMod=pval.mod, lenMod=length(i))
            })

        index <- order(do.call(rbind,output[[5]])[,2])
        output[[1]] <- output[[1]][index]
        output[[5]] <- output[[5]][index]

        slot(slot(pvalue_annotation, "score_data"), "module_output") <- output
        pvalue_annotation
    }
)


setMethod(
    f="runBioNet",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, network, alpha = 0.05)
    {
        if(any(alpha<0, alpha>1)){
            stop("Error: alpha must be between zero and one.")
        }
        if(length(slot(slot(pvalue_annotation,"score_data"),"module_output")) !=0 ){
            slot(slot(pvalue_annotation,"score_data"),"module_output") <- list()
            message("Overwriting existing modules.")
        }
        
        scores <- highScores(pvalue_annotation, alpha=alpha)
        pval.v <- exp(scores/(-2))
        g <- suppressWarnings(subNetwork(names(pval.v), network))
        g <- rmSelfLoops(g)
        if(inherits(g,what="igraph")){
            g <- igraph.to.graphNEL(g)
        }
        
        heinzOut <- suppressWarnings(runFastHeinz(g, scores))
        output <- list();
        output[[1]] <- list(heinzOut@nodes);
        output[[2]] <- pval.v;
        output[[3]] <- scores;
        output[[4]] <- g;
        output[[6]] <- "BioNet";
        
        names(output) <- c("modules",  "p_value",
                           "statistic","network","moduleStats","moduleType");
        sub_score <- subset(scores,names(scores)%in%output[[1]][[1]])
        stat.mod <- sum(abs(sub_score))
        pval.mod <- 1-pchisq(stat.mod,2*length(output[[1]][[1]]))
        output[[5]] <-
            list(c(statMod=stat.mod, pvalMod=pval.mod,
                   lenMod=length(output[[1]][[1]]))
            )
        
        
        names(output[[1]])[1] <-
            names(sub_score[which(sub_score==max(sub_score))[1]]
            )
        slot(slot(pvalue_annotation,"score_data"),"module_output") <- output
        pvalue_annotation
    }
)

setMethod(
    f="runGOseq",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, p_thresh=0.05, supply_cov=TRUE, coverage=NULL, type="reactome")
    {
        while(!names(dev.cur()) %in% c("pdf","null device")){
            dev.off()
        }
        names.eid <- names(slot(slot(pvalue_annotation, "score_data"),
                              "module_output")$modules)
        eid <- slot(slot(pvalue_annotation, "score_data"), "module_output")$modules
        pval <- slot(slot(pvalue_annotation, "score_data"), "module_output")$p_value
        stat <- slot(slot(pvalue_annotation, "score_data"), "module_output")$statistic
        genes <- names(slot(slot(pvalue_annotation, "score_data"), "module_output")$modules)
        goseqdata <- slot(slot(pvalue_annotation, "score_data"), "module_output")$modules

        sym2eg <- AnnotationDbi::as.list(org.Hs.eg.db::org.Hs.egSYMBOL2EG)
        eg2sym <- AnnotationDbi::as.list(org.Hs.eg.db::org.Hs.egSYMBOL)

        if(type == "reactome"){

            eg2reactome <-
                AnnotationDbi::as.list(reactome.db::reactomeEXTID2PATHID)
            temp <- sapply(names(eg2reactome), function(y){
                eg2sym[[as.character(y)]]})
            temp <- lapply(temp, function(y){if(is.null(y)){y<-NA};y})
            temp2 <- do.call("c", temp)
            sym2network <- eg2reactome
            names(sym2network) <- temp2
            PATHID2NAME <- AnnotationDbi::as.list(reactome.db::reactomePATHID2NAME)

        }

        if(type == "kegg"){
            link_kegg<- KEGGREST::keggLink("pathway", "hsa") ## returns pathways for each kegg gene
            list_link <- split(unname(link_kegg), names(link_kegg)) ## combines each pathway into list object for each gene
            names(list_link) <- do.call(rbind, strsplit(names(list_link), ":"))[,2]
            temp <- sapply(names(list_link), function(y){
              eg2sym[[as.character(y)]]})
            temp <- lapply(temp, function(y){if(is.null(y)){y<-NA};y})
            temp2 <- do.call("c", temp)
            sym2network_2 <- list_link
            names(sym2network_2) <- temp2
            pathways <- KEGGREST::keggList("pathway", "hsa") ## returns the list of human pathways
            PATHID2NAME <- as.list(pathways)
        }

        names(eid) <- paste("module_", names(eid), "_network", sep="")
        nl <- unlist(goseqdata)
        nl <- cbind(names(nl), nl)
        rownames(nl) <- NULL
        nl[, 1] <- gsub("[0-9]*$", "", nl[, 1])
        nl <- split(nl[, 1], nl[, 2])
        nl <- lapply(nl, function(i){unique(i)})

        if (supply_cov == FALSE) {
          annotations <- slot(slot(pvalue_annotation, "annotation"),"unlistData") # pvalue_annotation@annotation@unlistData
          annotations_split <- split(annotations, slot(annotations,"elementMetadata")$name)
          anntation_red <- reduce(annotations_split)
          
          # make granges for modification
          red_meth <- reduce(slot(slot(pvalue_annotation, "modifications"),"unlistData")) # pvalue_annotation@modifications@unlistData
          anno_CpGs2 <- countOverlaps(anntation_red,red_meth)
          a <- data.frame(id=names(anno_CpGs2), Overlaps=anno_CpGs2)
        }
        if (supply_cov == TRUE & is.null(coverage)) {
          stop("Supply coverage marked TRUE, but no coverage supplied. Please 
               supply coverage as a data.frame (bed file) or a character vector (gene Symbol or RefSeq)")
        }
        if (supply_cov == TRUE) {
          if(inherits(coverage, what="data.frame")){
            a <- coverage
            a <- a[, 4:5]
          }
          if(inherits(coverage, what="character")){
            if(coverage == "refseq"){
              hg19.refGene.LENGTH <- NULL
              data(hg19.refGene.LENGTH,package="geneLenDataBase",
                   envir=environment())
              a <- hg19.refGene.LENGTH[, c(1, 3)]
            }
            if(coverage == "symbol"){
              hg19.geneSymbol.LENGTH <- NULL
              data(hg19.geneSymbol.LENGTH,package="geneLenDataBase",
                   envir=environment())
              a <- hg19.geneSymbol.LENGTH[, c(1, 3)]
            }
          }
        }
            
        if(any(duplicated(a[, 1]))){
            a <- split(a, a[, 1])
            a <- lapply(a, function(i){
                if(nrow(i) > 1){
                    i <- i[which(i[, 2] == max(i[, 2])), ]
                };
                i
            })
            a <- do.call(rbind, a)
        }

        slot(slot(pvalue_annotation, "score_data"), "module_output")$goseqOut <-
            lapply(slot(slot(pvalue_annotation, "score_data"),
                        "module_output")$modules, function(i){
                            b <- cbind(a[, 1], rep(0, nrow(a)))
                            b[which(b[, 1]%in%i), 2] <- 1
                            x <- as.vector(b[, 2])
                            x <- as.numeric(x)
                            names(x) <- b[, 1]
                            pwf <- goseq::nullp(x, 'h19', 'knownGene', bias.data=a[, 2])
                            path <- goseq::goseq(pwf, "hg19", "knownGene",
                                          gene2cat=sym2network)
                            path <- cbind(path,(as.character(sapply(
                                path$category, function(i){PATHID2NAME[[i]]}))))
                            colnames(path)[6] <- "cat_name"
                            subset(path, path$over_represented_pvalue < p_thresh)
                        }
                   )
        pvalue_annotation
    }
)




setMethod(
    f="searchGOseq",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, search_string, wholeword=FALSE){
        options(stringsAsFactors=FALSE)
        search_string<-tolower(search_string)
        nums <- which(do.call("c", lapply(
            slot(slot(pvalue_annotation, "score_data"), "module_output")$goseqOut,
            function(each){
                any(grepl(ifelse(wholeword == FALSE, search_string,
                                 paste("\\b", search_string, "\\b", sep="")),
                          tolower(each[, ncol(each)])))
                }
            ))
        )
        if(length(nums) > 0){
            out <- lapply(nums, function(i){
                pos <- grep(ifelse(wholeword == FALSE, search_string,
                                   paste("\\b", search_string, "\\b", sep="")),
                            tolower(slot(slot(pvalue_annotation, "score_data"),
                                         "module_output")$goseqOut[[i]][, 6]))
                tot <- nrow(slot(slot(pvalue_annotation, "score_data"),
                                 "module_output")$goseqOut[[i]])
                outterm <- as.data.frame(as.character(slot(
                    slot(pvalue_annotation, "score_data"),
                    "module_output")$goseqOut[[i]][pos, 6]))
                cbind(outterm, as.data.frame(pos),
                      as.data.frame(rep(tot,length(pos))))
            })
            out <- lapply(1:length(nums), function(i){
                old <- out[[i]]
                rownames(old) <- NULL
                old <- cbind(rep(names(nums)[i], nrow(old)),
                        rep(as.numeric(nums[i]), nrow(old)), old)
                old
            })
            out <- do.call(rbind, out)
            out[,2] <- sapply(out[,2], function(i){
                i <- as.numeric(i);
                i <- paste(i, "/", round(slot(
                    slot(pvalue_annotation, "score_data"),
                    "module_output")$moduleStats[[i]][2],4));
                i
            })

            colnames(out) <- c("epimod_name", "epimod_position_pval",
                               "term", "rank_of_term", "total_terms")
            rownames(out) <- NULL
            out
        }
        else {
            message("Search term not found.")
        }
    }
)

setMethod(
    f="extractGOseq",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, which_network=NULL){
        temp <- slot(slot(pvalue_annotation, "score_data"), "module_output")$goseqOut
        if(!is.null(which_network)){temp <- temp[which_network]}
        temp
    }
)






setMethod(
    f="extractModification",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, mod_type=NULL){
        if(!is.null(mod_type)){
            if(!mod_type%in%names(slot(pvalue_annotation,
                                      "modifications")@metadata$elements)){
                stop("Provided mod_type is not in the PvalueAnnotation object.")
            }
        }

        temp_meta <- slot(slot(pvalue_annotation,"modifications"),"metadata")
        temp <- unlist(slot(pvalue_annotation,"modifications"))
        names(temp) <- NULL

        if(is.null(mod_type)){mod_type <- unique(temp$type)}
        temp<-subset(temp, temp$type %in% mod_type)
        slot(temp, "metadata") <- temp_meta
        temp
    }
)

setMethod(
    f="extractExpression",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation){
        if(is.null(expression)){
            stop("No expression data loaded.")
        }
        temp_exp <- slot(pvalue_annotation,"expression")
        Biobase::pData(temp_exp)
    }
)




setMethod(
    f="extractModSummary",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation){
        temp_meta<-slot(slot(pvalue_annotation,"modifications"),"metadata")
        temp_meta$m_summary
    }
)

setMethod(
    f="extractScores",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation){
        if(nrow(slot(slot(pvalue_annotation,"score_data"),"scores")) == 0){
            stop("Run scorePval function first.")
        }
        temp <- slot(slot(pvalue_annotation,"score_data"),"scores")
        names_temp <- rownames(temp)
        temp <- as.vector(temp[,1])
        names(temp) <- names_temp
        temp
    }
)

setMethod(
    f="highScores",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, alpha=0.05){
        if(nrow(slot(slot(pvalue_annotation,"score_data"),"scores")) == 0){
            stop("Run scorePval function first.")
        }
        if(any(alpha < 0, alpha > 1)){
            stop("alpha must be between 0 and 1")
        }

        temp <- slot(slot(pvalue_annotation,"score_data"),"scores")
        names_temp <- rownames(temp)
        temp <- as.vector(temp[,1])
        names(temp) <- names_temp
        rand_mat <- as.matrix(sapply(1:100, function(j){
            sample(temp, replace=TRUE)
            }))
        new_pval <- sapply(temp , function(i){
            length(which(rand_mat > as.numeric(i)))/(100*length(temp))
        })
        new_pval <- replace(new_pval, new_pval == 0,
                            min(subset(new_pval, new_pval != 0), na.rm=TRUE))
        temp[which(new_pval < alpha)]
    }
)

setMethod(
    f="addShadowText",
    signature="ANY",
    definition=function(x, y=NULL, labels, col='white', bg='black',
                        theta=seq(pi/4, 2*pi, length.out=8), r=0.1, ...) {

        xy <- xy.coords(x,y)
        xo <- r*strwidth('A')
        yo <- r*strheight('A')
        for (i in theta) {
            text( xy$x + cos(i)*xo, xy$y + sin(i)*yo,
                  labels, col=bg, ... )
        }
        text(xy$x, xy$y, labels, col=col, ... )
    }
)

setMethod(
    f="extractModules",
    signature="PvalueAnnotation",
    definition=function(pvalue_annotation, which_module=NULL){
        if(length(slot(slot(pvalue_annotation, "score_data"),
                       "module_output")$modules) == 0) {
            stop("Spinglass or Bionet analysis has not been performed.")
        }
        temp <- slot(slot(pvalue_annotation,"score_data"),"module_output")$modules
        if(!is.null(which_module)){
            temp <- temp[which_module]
        }
        temp
    }
)

setMethod (
    "print",
    signature="PvalueAnnotation",
    function(x,...){
        cat("*** Class P-value Annotation, method Print *** \n")
        if(nrow(exprs(slot(x,"expression"))) == 0){
            cat("* Expression data :"); print("0 entries")
        }
        else {
            cat("* Expression data :");
            print(Biobase::pData(slot(x,"expression")));
            print(paste("Expression has",
                        nrow(Biobase::pData(slot(x, "expression"))),
                        "entries"))
        }
        readline()
        if(length(unlist(slot(x,"modifications"))) == 0){
            cat("* Modification data :"); print("0 entries")
        }
        else{
            for(i in unique(unlist(slot(x, "modifications"))$type)){
                cat(paste("*", i, "data :"));
                print(subset(unlist(slot(x, "modifications")),
                             unlist(slot(x, "modifications"))$type==i));
                print(paste(i,"has", length(
                    subset(unlist(slot(x, "modifications")),
                           unlist(slot(x, "modifications"))$type==i)), "entries"))
            }
        }
        readline()
        if(nrow(slot(slot(x,"score_data"), "pval_data")) == 0){
            cat("* Score data :"); print("0 entries")
        }
        else {
            cat("* Score data :"); print(slot(slot(x,"score_data"),"scores"))
            print(paste("Score data has",
                        nrow(slot(slot(x, "score_data"), "scores")),
                        "entries"))
        }
        readline()
        cat("******* End Print (PvalueAnnotation) ******* \n")
    }
)

---
title: '**SMITE** Vignette'
author: "Andrew D. Johnston, N. Ari Wijetunga, and John M. Greally"
date: "July 28, 2015"
output: pdf_document
fontsize: 12pt
vignette: >
    %\VignetteIndexEntry{SMITE Tutorial}
    %\VignetteEngine{knitr::rmarkdown}
    \usepackage[utf8]{inputenc}
---


\section*{\centering{Abstract}}
\begin{quote}
This tutorial exemplifies how \textbf{SMITE} can inegrate the results from gene expression and epigenome wide studies to identify functional modules, subnetworks within a gene interaction network. Here we will take gene expression, DNA methylation and publicly available ChIP-seq results simulated from a large multi-level unpublished study, and we will generate significance-based functional modules. The main aim of our example is to find functional modules that characterize processes related to the infection of HFF cells with \textit{Toxoplasma Gondii} when compared to uninfected controls. In the process, we detail how to set-up \textbf{SMITE}, curate data for input, use \textbf{SMITE} commands, and annotate/visualize modules. 
\end{quote}

\section{1 Setup Environment}
First, we will set our environment parameters and install the **SMITE** package. The package can be found on [Github](https://github.com/GreallyLab/SMITE) 
```{r, warning=FALSE, message=FALSE, eval=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=50), echo=TRUE, results='hide'}
options(stringsAsFactors=FALSE)
library(SMITE)
```
    
\section{2 Curate Data}
Before inputting epigenetic and expression data into the **SMITE** algorithms, expression, DNA methylation, and annotation tracks need to be in the proper format.  Because genomics data can come in many different formats, pre-processing the data is important to establish uniformity in downstream results.  Within the package, there is curated, pre-processed data available for testing as well.

Start by loading in a DNA methylation dataset(Chr, Start, Stop, effect size, p-value for each CpG). This data was generated using the HELP-tagging assay and shows the difference of mean 5'-cytosine methylation between triplicate \textit{Toxoplasma} infected and uninfected Human Foreskin Fibroblasts (HFF). The p-value was generated using t-tests (DNA methylation ~ Infection).      

To curate the DNA methylation dataset, it is necessary to remove uninformative loci (`NAs`) and p-values=0 since logarithms of p-values are employed within the code.  We replace any p-values=0 with the minimum p-value in the dataset. We also remove CpGs for which the p-value is `NA`.  The curated datasets available through [Github](https://github.com/GreallyLab/SMITEdatasets) have already been processed but were not included in the package because of size restrictions.

```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE}
## Load methylation data ##
data(methylationdata)
head(methylation)
## Replace zeros with minimum non-zero p-value ##
methylation[,5] <- replace(methylation[,5], methylation[,5]==0, 
                           min(subset(methylation[,5], methylation[,5]!=0), na.rm=TRUE))

## Remove NAs from p-value column ##
methylation <- methylation[-which(is.na(methylation[, 5])), ] 
``` 

Before integrating data from multiple datasets, it is \textbf{EXTREMELY} important that you choose a single gene ID platform that you will use for the entire analysis. Any form of gene ID will work as long as every dataset uses it or efforts are made to convert gene IDs. We prefer to use gene symbols to avoid downstream networks cluttered by multiple transcripts of the same gene, and we assign gene symbols to our expression dataset instead of RefSeq IDs using a convenient function. If starting from a different gene ID system, one can also convert ensemble, ensembleprot, and uniprot gene IDs to their respective gene symbols (See Manual).  The `convertGeneIds` function enumerates the combinations of to and from, so if a particular annotation is desired, we can add the functionality, if requested. 

```{r, warning=FALSE, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE}
## Load fake genes to show expression conversion ##
data(genes_for_conversiontest)
genes[,1] <- convertGeneIds(gene_IDs=genes[,1], ID_type="refseq", ID_convert_to="symbol")
```


Next, we load in the example expression dataset (genes, effect, p-value) generated via RNA-seq on the same HFF samples. Because of size restrictions, we could not include an unprocessed dataset. We have, however, provided an unprocessed dataset on [Github](https://github.com/GreallyLab/SMITEdatasets) for users to apply the following lines of codes to in order to better see how to pre-process their data. In the curated data, the rownames are gene symbols  and the other columns include effect size (log fold change) and p-value from a negative binomial test in DESeq.   

After gene id conversion (example shown above), we remove expression data for genes where a gene symbol was not found (`NAs`). We then take the lowest (most significant) pvalue for genes that had more than 1 entry. Finally, we replace p-values of zeros with the lowest p-value in the dataset.  

```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=FALSE}
## This is just an example of how to pre-process data ##
expression <- expression[-which(is.na(expression[, 1])), ]
expression <- split(expression, expression[, 1])
expression <- lapply(expression, function(i){
    if(nrow(as.data.frame(i)) > 1){
        i <- i[which(i[, 3] == min(i[, 3], na.rm=TRUE))[1], ]
        }
    return(i)}) 
expression <- do.call(rbind, expression)
expression <- expression[,-1]
expression[, 2] <- replace(expression[, 2],expression[, 2] == 0, 
                          min(subset(expression[, 2], expression[, 2] != 0), na.rm=TRUE))
```

```{r, warning=FALSE, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE}
## Load expression data ##
data(curated_expressiondata)

## View data ##
head(expression_curated)

```


Then, we load in gene sequences as well as other data that we wish to include in our analysis. These files must be in bed format with the first three columns as (chr,start,stop).  A gene strand and name are also required, but the downstream functions allow users to specify a column for strand and gene name.

```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE}
## Load hg19 gene annotation BED file ##
data(hg19_genes_bed)

## Load histone modification file ##
data(histone_h3k4me1)

## View files ##
head(hg19_genes)
head(h3k4me1)
```

\section{3 Integrate Datasets}

In `makePvalueAnnotation`, we create a `GRangesList` object where each gene is associated with a promoter region (+/- 1000bp from TSS), gene body region (TSS+1000bp to TES), and putative "enhancers" using H3K4me1 ChIP-seq peaks (+/- 5000bp from TSS).  Note: These are the sizes of regions of the genome for which we are interested in calculating scores, but the user can easily alter the parameters. Additionally, the argument otherdata can be an unlimited list of bed files that will be associated with genes and then scored in functional modules. The argument other_d is the distance from the TSS that will be used to associate each otherdata dataset with a gene.  If different distances are required for otherdata, then you must provide a distance for each dataset.

```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=50), eval=TRUE}
test_annotation <- makePvalueAnnotation(data=hg19_genes, other_data=list(h3k4me1=h3k4me1), 
                                        gene_name_col=5, other_tss_distance=5000, 
                                        promoter_upstream_distance=1000, promoter_downstream_distance=1000) 
```

Having created a `PvalueAnnotation`, we can now load in the expression and methylation dataset.  First we load the expression data.  If `effect_col` and `pval_col` are not provided, the program will attempt to find them using the column names, but its probably safer to just provide the arguments.  
```{r,  tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=50), eval=TRUE}
test_annotation <- annotateExpression(pvalue_annotation=test_annotation, expr_data=expression_curated, 
                                      effect_col=1, pval_col=2)
```

To load in modification data, we have provided a function that can be used multiple times, once for each modifcation data type (e.g. DNA methylation, DNA hydroxymethylation).  This is accomplished by using the `mod_type` character string, which can be any word. Please do not use an underscore or names that are nested in one another (e.g. methylation and methyl) as this will cause erratic behavior when string splitting column names downstream.  For each loaded modification, when `mod_corr=TRUE` (DEFAULT);set as `FALSE` to reduce computation time) the function will determine a correlation structure, adjust the p-values and combine the p-values using the method specified (here, Stouffer's method (DEFAULT)).  In addition, we use a Monte Carlo Method (MCM) of random sampling of the combined scores to determine a FDR like p-value which will used as the p-value/score in downstream analysis.  When combining p-values using any method (see companion paper or `?annotateModification` for more details), p-values will be combined over the gene promoters (DEFAULT), gene bodies (DEFAULT), and over any provided other datasets.  Stouffer's method allows optional weights to be given, which we define here has `"distance"` (weighting the effect and p-value by distance from the TSS), `"pval"` (weighting the effect by the signifcance of the effect), or anything other text (unweighted).  Note: Depending on the amount of data, this step can take roughly 10 minutes per `mod_type`.
```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=45), eval=FALSE}
test_annotation <- annotateModification(test_annotation, methylation, weight_by_method="Stouffer", 
                                      weight_by=c(promoter="distance", body="distance", h3k4me1="distance"),
                                      verbose=TRUE, mod_corr=FALSE, mod_type="methylation")
```

We can view the loaded data using the following functions:

```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=50), eval=FALSE, fig.width= 9}
## See expression data ##
head(extractExpression(test_annotation))

## See the uncombined p-values for a specific or all modType(s) ##
extractModification(test_annotation, mod_type="methylation")

## See the combined p-value data.frame ##
head(extractModSummary(test_annotation))
```


\section{4 Adjusting Values and Scoring}

Having loaded gene expression and DNA methylation data into the `PvalueAnnotation`, we now bring all of the data together into an object class called a `PvalueObject`.  The `PvalueObject` we will create has a slot within the `PvalueAnnotation` called `score_data` accessed through `slot(PvalueAnnotation, "scoredata")` or one of the accessor functions that we have set up like `SMITEextractScores`.  At this step we specify an \textit{a priori} argument that will be used in scoring downstream `effect_directions`.  We must specify an `effect_directions` element for each modification-context pairing that we wish to score.  It should reflect whether you want your modification-context (e.g. DNA methylation in gene promoters) to have a pre-specified relationship with expression so that if the opposite relationship is observed the score will be penalized. Users can specify either `"increase"`, `"decrease"` and `"bidirectional"` (for no prespecifed relationship).  This information will be stored and will not be used until the `SMITEscorePval` function is used.

```{r,  tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=35), eval=FALSE}
test_annotation <- makePvalueObject(test_annotation, effect_directions=c(methylation_promoter="decrease", 
                                                                         methylation_body="increase", methylation_h3k4me1="bidirectional"))
```   

P-values/scores that are combined and then randomized will have a different range than gene expression, or one another, which can skew the identified modules toward a particular modification-context pairing.  Using the `plotDensityPval` function we view the distribution and then normalize using the `normalizePval` function if necessary.  Using the (DEFAULT) `rescale` procedure, p-values are logit transformed before rescaling resulting in a shifting of an approximately normal distribution and no effect on the order of p-values within a modification-context pairing.

```{r, echo=FALSE, eval=TRUE}
## Because runSpinglass and scorePval are computationally intensive we simply load already ran data instead of evaluating the code.
data(test_annotation_score_data)
```

```{r,  tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=35), eval=TRUE}
## Plot density of p-values ##
plotDensityPval(pvalue_annotation=test_annotation, ref="expression")
```
```{r,  tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=35), eval=TRUE, fig.width=9, fig.height=5}
## Normalize the p-values to the range of expression ##
test_annotation <- normalizePval(test_annotation, ref="expression", 
                                 method="rescale")
```   
We can compare p-values for different features using the `plotCompareScores` function, with the hope that it may reveal interesting patterns within the data.

```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=35), eval=TRUE, fig.width=8}
plotCompareScores(test_annotation, x_name="expression", y_name="methylation_promoter")
```

Scoring the genes is the final step before finding modules, and after scoring, the high scoring genes can be extracted using the `SMITEhighScores` function.  When using `SMITEscorePval`, users can provide an optional weighting vector that will allow prioritization of certain modfication-context pairings.  We included this feature because we find that a researcher often has a specific goal (e.g. finding DNA methylation that is significantly different at enhancer), and rather than allowing researchers to selectively choose results that support their hypothesis, it may be beneficial to define a numeric quantity that can be reported at the time of publication and reproduced.  We provide the `SMITEreport` function for text dump of all defined parameters.

```{r long-compute-time, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=45), eval=FALSE}
#score with all four features contributing
test_annotation <- scorePval(test_annotation, weights=c(methylation_promoter=.3, 
                                                        methylation_body=.1,
                                                        expression=.3,
                                                        methylation_h3k4me1=.3))
```

\section{5 Visualize Modules}
Now that we have generated weighted significance values from different modifications that relate to each gene, we can visualize modules using interactome data and module-building packages, such as `BioNet`. Specifically, following the example of `Epimods` we use igraph's spinglass algorithm to determine the best modules.

First, we load the desired interactome, in our case from `REACTOME` and run the Spin-glass algorithm. We can then run a `goseq` like approach on our modules to annotate them using pathways, like `KEGG`. 
```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=45), eval=FALSE}
## load REACTOME ## 
 load(system.file("data","Reactome.Symbol.Igraph.rda", package="SMITE"))
## Run Spin-glass ##
test_annotation <- runSpinglass(test_annotation, network=REACTOME, maxsize=50, num_iterations=1000)

## Run goseq on individual modules to determine bias an annotate functions ## 
test_annotation <- runGOseq(test_annotation, supply_cov=TRUE, coverage=read.table(system.file(
    "extdata", "hg19_symbol_hpaii.sites.inbodyand2kbupstream.bed.gz", package="SMITE")),
    type="kegg")
```


We can use keywords such as "cell cycle" to find within the goseq output which modules we are most interested. We can then use `SMITEplotModule` to visualize the module. 
```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE, fig.width=10, fig.height=9}
## search goseq output for keywords ##
searchGOseq(test_annotation, search_string="cell cycle")
```
```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE, fig.width=10, fig.height=9}
## Draw a network ##
plotModule(test_annotation, which_network=6, layout="fr", label_scale=TRUE, compare_plot = FALSE)
## Compare two networks ##
plotModule(test_annotation, which_network=c(4,6), layout="fr", label_scale=TRUE, compare_plot = TRUE)

```
```{r, tidy=TRUE, tidy.opts=list(blank=FALSE, width.cutoff=60), eval=TRUE, fig.width=12,fig.height=6}
## Draw a network with goseq analysis ##
plotModule(test_annotation, which_network=1, layout="fr", goseq=TRUE, label_scale=FALSE)
```

\name{convertGeneIds}
\alias{convertGeneIds,character,character,character-method}
\alias{convertGeneIds}
\title{
Convert between gene ids
}
\description{
A convenient function used to convert between gene ids from different
gene annotations.
}
\usage{
convertGeneIds(gene_IDs, ID_type, ID_convert_to, delim = NULL, verbose = FALSE)
}
\arguments{
  \item{gene_IDs}{
A vector of gene names.
}
  \item{ID_type}{
A character specifying the type of given annotation.  Currently one of "refseq",
"ensembleprot","uniprot" or "ensemble". In the case of ID_convert_to="entrez", "symbol"
}
  \item{ID_convert_to}{
A character specifying the type of desired annotation.  Currently one of 
"symbol" or in they case of ID_type="symbol", "entrez"
}
  \item{delim}{
An optional character that will be removed from the beginning of each gene 
name.  It can be a long string.
}
  \item{verbose}{
TRUE/FALSE Should the function be verbose?  DEFAULTS to FALSE.
}
}
\details{
This is a very usefule function to efficently convert between gene ids.  It
currently relies on enumeration of each possible conversion, which has limited
it's use to mainly converting to gene symbol.

}
\value{
A character vector formatted to ID_convert_to
}
\author{
N. Ari Wijetunga < Neil.Wijetunga@med.einstein.yu.edu >
}
\note{
The function has enumerated combinations using AnnotationDBI.  We can provide 
additional functionality if needed.
}

\seealso{
AnnotationDBI, Biomart
}
\examples{

data(genes_for_conversiontest)

genes[,1] <- convertGeneIds(gene_IDs=genes[,1], ID_type="refseq",
                            ID_convert_to="symbol")
                                                 
}
\keyword{SMITE }
\keyword{ convert }
\keyword{ ids }

\name{extractScores}
\alias{extractScores}
\alias{extractScores,PvalueAnnotation-method}
\title{
Extract scores for all genes
}
\description{
A function to obtain all gene scores
}
\usage{
extractScores(pvalue_annotation)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation for which scores have already
been calculated
}
}

\value{
A named vector containing all gene scores
}
\author{
N. Ari Wijetunga
}
\seealso{
scorePval
extractModules
highScores
}
\examples{
data(test_annotation_score_data)

out <- extractScores(pvalue_annotation=test_annotation)

head(out)

}

\name{genes_for_conversiontest}
\alias{genes_for_conversiontest}
\alias{genes}
\docType{data}
\title{
A small set of RefSeq genes for converting
}
\description{
This toy dataset has 100 randomly selected RefSeq genes and can be used to test 
conversion functionality in SMITE
}
\usage{data("genes_for_conversiontest")}
\format{
  A data frame with 100 observations on the following 1 variables.
  \describe{
    \item{column1}{a character vector of RefSeqGene IDs}
  }
}
\value{
A dataframe with genes in Refseq format for conversion testing.
}

\examples{

data("genes_for_conversiontest")

genes[,1]<-convertGeneIds(gene_IDs=genes[,1], ID_type="refseq",
                          ID_convert_to="symbol")

}
\keyword{datasets}

\name{test_annotation_score_data}
\alias{test_annotation_score_data}
\alias{test_annotation}
\docType{data}
\title{
A toy PvalueAnnotation
}
\description{
 This Pvalue annotation has only scoring data filled in to use in late
pipeline "SMITE" functions.  It can be used to skip the loading data phase
of analysis and test latter functionality.
}
\usage{data("test_annotation_score_data")}
\format{
  A PvalueAnnotation with the following slots
  \describe{
    \item{score_data}{a PvalueObject with slots corresponding to pval_data,
    effect_data, genes, signs_index, scores, trans, scoring_vector, and 
    module_otuput}
  }
}
\details{
This is a PvalueAnnotation which has had all of the pre-scoring data 
removed so that it is only usefule for using functions beginning with SMITE
and SMITE plotting functions.
}
\value{
A PvalueAnnotation with the score_data slot containing toy scores
}

\examples{
data(test_annotation_score_data)
plotDensityPval(test_annotation)
head(extractScores(test_annotation))

}
\keyword{datasets}

\name{runSpinglass}
\alias{runSpinglass}
\alias{runSpinglass,PvalueAnnotation-method}
\title{
Run Spinglass algorithm on a Scored PvalueAnnotation
}
\description{
This function is a  function to prepare the data for calling the Spinglass 
network algorithm.
}
\usage{
runSpinglass(pvalue_annotation, network, random_alpha = 0.05, gam = 0.5, 
node_alpha = 0.05, maxsize = 500, minsize = 8, num_iterations = 1000, simplify = TRUE)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation
}
  \item{network}{
An graph object of class graphNEL or igraph
}
  \item{random_alpha}{
A numeric specifying a threshold with with to determine module signficance 
after randomization
}
  \item{gam}{
A parameter used by the Spinglass algorithm
}
  \item{node_alpha}{
The proportion of nodes to be used as seeds for the community detection
}
  \item{maxsize}{
The maximum module size
}
  \item{minsize}{
The minimum module size
}
  \item{num_iterations}{
The number of randomizations that will be computed to determine whether the
module is significant by chance
}
 \item{simplify}{
A logical (TRUE(DEFAULT)/FALSE) that specifies whether network should be
simplified by removing self loops and repeated edges
}
}
\details{
In the provided Epimods reference, West et al outlined the advantages of using 
the spin-glass algorithm in the detection of modules.  Please consult the 
reference for more detailed information on the spin-glass algorithm  implemented
in the package igraph.

Like Epimods, this function employs the spin-glass algorithm implemented in 
igraph and uses random permutations to assess the "modularity," the number and 
strength of connected nodes, of a module.  However, SMITE scores are interpreted
as Chi-square distributed statistics whenever possible, rather than the
weighted-T-statistic in Epimods.

}
\value{
An S4 object of class PvalueAnnotation with modules loaded
}
\references{
James West, Stephan Beck, Xiangdong Wang & Andrew E. Teschendorff
An integrative network algorithm identifies age-associated differential 
methylation interactome hotspots targeting stem-cell differentiation pathway. 
Scientific Reports 3, Article number: 1630 (2013)

https://code.google.com/p/epimods/

}
\author{
N. Ari Wijetunga
}
\note{
This function was adapted from a function in the Epimods package that 
employs the spin-glass algorithm and uses random permutations to assess
the "modularity" of a module . The original function was created by West et al.
}

\seealso{
FEM
runBioNet
extractModules
plotModule
}
\examples{
data(test_annotation_score_data)

#load(system.file("data","Reactome.Symbol.Igraph.rda", package="SMITE"))
 
## NOTE: commented out for example.  See vignette for better explanation ##
#test_annotation <- runSpinglass(pvalue_annotation=test_annotation, 
#network=REACTOME, maxsize=50, num_iterations=10)

plotModule(test_annotation, which_network=6, layout="fr")

}

\name{removeModification}
\alias{removeModification}
\alias{removeModification,PvalueAnnotation-method}
\title{
A function to "unload" a modification that has already been added.
}
\description{
After using the annotateModification function to load a modification into a
PValue annotation, you may wish to remove a modification or reannotate one,
which requires removing it first.
}
\usage{
removeModification(pvalue_annotation, mod_type = "methylation")
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation
}
  \item{mod_type}{
A character string that identifies a type of modification within a 
PvalueAnnotation.  
}
}
\value{
An S4 object of class PvalueAnnotation
}
\author{
N. Ari Wijetunga
}
\seealso{
annotateModification
extractModification
extractModSummary
}
\examples{
##NOTE: Commented out in example. ##
## Please see vignette for more detailed usage information ##

## Load genome bed file ##

#data(hg19_genes_bed)

## Load curated DNA methylation bed file ##

data(methylationdata)
methylation <- methylation[-which(is.na(methylation[, 5])), ]
methylation[, 5] <- replace(methylation[, 5], methylation[, 5] == 0, 
    min(subset(methylation[, 5], methylation[, 5] != 0), na.rm=TRUE))

#meth1<-methylation

## make second curated test methylation bed file ##

#meth2<-methylation

## Create a PvalueAnnotation with defaults for promoter size##
#test_annotation<-makePvalueAnnotation(data=hg19_genes, gene_name_col=5)

## Load DNA methylation into PvalueAnnotation ##
#test_annotation<-annotateModification(annotation=test_annotation, 
#mod_data=meth1, weight_by=c(promoter="distance",body="distance"),verbose=TRUE,
#mod_corr=TRUE,mod_type="methylation")

## Extract GRanges with modification data ##
#extractModification(test_annotation)

## Load second dataset bed file ##
#test_annotation<-annotateModification(pvalue_annotation=test_annotation, 
#mod_data=meth2, weight_by=c(promoter="distance",body="distance"),
#verbose=TRUE, mod_corr=TRUE,mod_type="hydroxy")

## Extract GRanges with both modification dataset loaded ##
#head(extractModification(test_annotation,"hydroxy"))

## Unload DNA hydroxymethylation form PvalueAnnotation ##

#test_annotation<-removeModification(pvalue_annotation=test_annotation, 
                                    #mod_type="hydroxy")

## Extract GRanges to see only one modification dataset loaded ##
#head(extractModification(pvalue_annotation=test_annotation))

}

\keyword{ SMITE }
\keyword{ epigenetics }

\name{normalizePval}
\alias{normalizePval}
\alias{normalizePval,PvalueAnnotation-method}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
This function normalizes p-values (Scores) that are otherwise on different 
scales.
}
\description{
This function is a used to rescale compenent scores when distributions
have been altered.  There are two methods available.}
\usage{
normalizePval(pvalue_annotation, trans, ref = "expression_pvalue", method = "rescale")
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class p-value annotation
}
  \item{trans}{
A vector specifying a specific Box-cox power transformation to use. If not 
specified, the optimal transformation powers will be estimated. 
}
  \item{ref}{
A string that will be grepped from the names of the loaded expression data or
modification/context pairing.  All scores will be rescaled to match this 
reference's range.  The DEFAULT is expression.
}
  \item{method}{
A string of either

                    "Rescale"   DEFAULT
                    "rescale"
                                Performs a logit transform and rescales all
                                probabilites to the reference's logit 
                                transformed scale, then back-transforms

                    "Box-Cox"
                    "box-cox"
                    "boxcox" 
                    "Boxcox"
                                For each probility vector does a logit transform
                                and then iterates between 0.5 and 0.95 by 0.05
                                to determine the most similar transformation
                                to the logit transformed referece by a Wilcoxon-
                                test
}
}
\details{
Normalization may not be necessary but should improve some p-values from driving
the majority of downstream scores and modules solely because of the scale of 
their p-values.  All transformations are monotonic and are controlled for by
use of randomization prodecure downstream.
procedures downstream should }
\value{
An S4 object of class PvalueAnnotation with normalized p-values withing the
pval_data slot of the PvalueObject "score_data" slot

Plots densities of p-values before and after transform
}
\author{
N. Ari Wijetunga
}
\seealso{
makePvalueObject
scorePval
plotDensityPval
}
\examples{
data(test_annotation_score_data)

#test_annotation<-normalizePval(pvalue_annotation=test_annotation)

}

\name{hg19_genes_bed}
\alias{hg19_genes_bed}
\alias{hg19_genes}
\docType{data}
\title{
A bed file annotating Refseq genes for the hg19 genome build
}
\description{
A gene anntation BED file containing columns for RefSeq name and Gene Symbol
}
\usage{data("hg19_genes_bed")}
\format{
  A data frame with 41633 observations on the following 6 variables.
  \describe{
    \item{column 1}{a character vector for chromosome}
    \item{column 2 }{an integer vector for start position}
    \item{column 3 }{an integer vector for end position}
    \item{column 4 }{an character vector for RefSeq gene names}
    \item{column 5 }{an character vector for Gene Symbol names}
    \item{column 6 }{an character vector for strand}
  }
}
\details{
A BED files taken from the table browser.
}
\value{
A dataframe in BED format (chromosome, start, end) with additional columns for
gene name as Refseq and gene symbol and strand.
}
\source{
Karolchik D, Hinrichs AS, Furey TS, Roskin KM, Sugnet CW, Haussler D, Kent WJ. 
The UCSC Table Browser data retrieval tool. Nucleic Acids Res. 2004 Jan 1;32
(Database issue):D493-6.
}
\references{
http://genome.ucsc.edu/
}
\examples{
data(hg19_genes_bed)
}
\keyword{datasets}

\name{makePvalueAnnotation}
\alias{makePvalueAnnotation}
\alias{makePvalueAnnotation,ANY-method}
\title{
Initialize a PvalueAnnotation
}
\description{
This function initializes a PvalueAnnotation using a gene BED file and optional
BED files corresponding to interval datasets.  This is a necessary first step
in order to establish for each gene the gene promoter, body and associated
intervals.
}
\usage{
makePvalueAnnotation(data, other_data = NULL, other_tss_distance = 10000, 
    promoter_upstream_distance = 1000, promoter_downstream_distance = 1000, 
    strand_col = NULL, gene_name_col = NULL)
}
\arguments{
  \item{data}{
A required gene annotation BED file like that obtained from the UCSC Table 
Browser. At a minimum BED files must have the first three columns as 
(chromosome, start, end).  Additional required columns should correspond to the 
strand and gene name.The gene name needs to match the gene format desired
for the interaction network.  Duplicated gene names and associated gene
annotations are removed.

}
  \item{other_data}{
A list of BED files corresponding to each additional interval file to be
associated with genes.  The function will use the other_tss_distance variable
and the gene transcription start site (TSS) to find for each gene all intervals
within [tss-other_tss_distance, tss+other_tss_distance].
}
  \item{other_tss_distance}{
A vector specifying for each element of otherdata a distance from the gene
TSS to consider that interval as related to a gene.  If the length of 
other_tss_distance does not match the length of the otherdata list, then the 
first value is used for all datasets in the otherdata list. DEFAULTS to 10,000 base pairs.
}
  \item{promoter_upstream_distance}{
A numeric specifying how far upstream from the gene TSS is considered part of
the gene promoter. DEFAULTS to 1,000 base pairs.
}
  \item{promoter_downstream_distance}{
A numeric specifying how far downstream from the gene TSS is considered part of
the gene promoter.  Gene bodies subtract the promoter_downstream region.
DEFAULTS to 1,000 base pairs.
}
  \item{strand_col}{
A numeric specifying the column of the gene BED file (data) corresponding to 
the gene strand.  If this is not provided, the function will attempt to 
determine the strand.
}
  \item{gene_name_col}{
A numeric specifying the column of the gene BED file (data) corresponding to 
the gene name.
}
}
\details{
    The required only input file is the gene annotation BED file that should 
have (as all BED files) the chromosome, start and end  in columns 1,2 and 3, 
respectively.  Also, there should be a column for gene name and gene strand. 
The user needs to determine distance from the gene transcription start site that 
will define the gene promoter.  The gene body will then be calculated as the 
non-promoter overlapping sequence.  If optional BED files are given as
otherdata (e.g. transcription factor binding sites, histone modification peaks),
then the user will also decide a distance from the gene TSS to associate each
BED interval with a gene.  For a particular BED file, each genes may have more 
than one interval that falls within the desired range around a TSS.
    Unique gene names are required and the function  will automatically remove
duplicated genes.  We recommend deciding on an interaction network first and 
then loading a gene annotation BED file with the same names.  This will likely
necessitate allowing the function to pick one annotation of a gene, or pre-
processing using some criteria (e.g. longest transcript).
}
\value{
An S4 object of class PvalueAnnotation containing slots for an annotation
(GRangesList), an expression set, modifications (GRangesList), and a 
PvalueObject.
}
\author{
N. Ari Wijetunga
}

\seealso{
SMITE vignette
}
\examples{
## Note: Commented out below. See vignette for more detailed usage information##

## Load genome bed file ##
data(hg19_genes_bed)

## Create a PvalueAnnotation with defaults for promoter size##
test_annotation <- makePvalueAnnotation(data=hg19_genes, gene_name_col=5)

}
\keyword{ SMITE }
\keyword{ annotation }

\name{scorePval}
\alias{scorePval}
\alias{scorePval,PvalueAnnotation-method}
\title{
Making a single combined score for each gene
}
\description{
This function uses an a priori weighting scheme to combine scores for a given 
gene. 
}
\usage{
scorePval(pvalue_annotation, weights)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation, for which makePvalueObject has
already been run.
}
  \item{weights}{
A numeric vector of the relative importance of expression, modifications,
and genomic contexts toward the final score.  Names should be provided that 
match the "modfication_genomicfeature" format, except for expression.  While
the scores do not have to add up to 1, it is good practice to impose this 
restriction in order to track the relative importance.
}
}
\details{
Because each weighting scheme generates scores from a distribution that
will change depending on the analysis inputs, the function will randomly sample 
the final scores and compare each derived score to this simulated distribution.

If no names are given, then the function will assume the weights are in the
order that it finds a particular "modification_genomicfeature" and it will 
print the weighting scheme so that you can verify it is correct.  The total 
number of weights must match the total number of modifications*genomicfeatures+1
for expression.

After calculating a combined score (using a Stouffer's weighted statistic), 
a  new p-value is derived using a non-parametric sampling approach.
}
\value{
An S4 object of class PvalueAnnotation.
}
\author{
N. Ari Wijetunga
}
\examples{
options(stringsAsFactors=FALSE)

data(test_annotation_score_data)

## NOTE: commented out for example.  See vignette for better explanation ##
#test_annotation<-scorePval(pvalue_annotation=test_annotation,
#weights=c(methylation_promoter=.3,methylation_body=.1,expression=.3,
#methylation_h3k4me1=.3))

}

\keyword{ MonteCarlo }
\keyword{ SMITE }

\name{runBioNet}
\alias{runBioNet}
\alias{runBioNet,PvalueAnnotation-method}
\title{
Perform BioNet Analysis on a PvalueAnnotation
}
\description{
With BioNet, a researcher can find a single interconnected gene module using
the highest scoring genes generated in a PvalueAnnotation.  This function will
load the module into the PvalueAnnotation for visualization and downstream 
analysis.}
\usage{
runBioNet(pvalue_annotation, network, alpha = 0.05)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation that has already had scores generated.
}
  \item{network}{
An interaction network of class graphNEL or igraph.
}
  \item{alpha}{
A numeric specfiying a cutoff for high scoring genes to be return with the
highScores function.
}
}
\details{
The input of p-values to BioNet discussed in the BioNet vignette involves
first modeling p-values as a Beta-uniform mixture model to obtain the actual
corresponding probability function values.  Since our scoring method produces
p-values/scores that are uniform in distribution, we input them directly into
the BioNet algorithm.  For more details on BioNet see the reference or
runFastHeinz in the BioNet package.
}
\value{
A PvalueAnnotation with a loaded module.
}
\references{
Beisser et al.
BioNet: an R-Package for the functional analysis of biological networks.
Bioinformatics. 2010 Apr 15;26(8):1129-30. doi: 10.1093/bioinformatics/btq089. 
Epub 2010 Feb 25.

}
\author{
N. Ari Wijetunga
}
\note{
This is a wrapper function to run BioNet.  The actual BioNet 
code was created by Beisser et al.
}
\seealso{
plotModule
extractModule
runGOseq
}
\examples{
## load test data ##
data(test_annotation_score_data)

 
## NOTE: commented out for example.  See vignette for better explanation ##

#load reactome network with gene symbols ##
#load(system.file("data","Reactome.Symbol.Igraph.rda", package="SMITE"))

## run BioNet ##
#test_annotation<-runBioNet(pvalue_annotation=test_annotation,
#network = REACTOME)

## view module ##
#extractModules(pvalue_annotation=test_annotation, 1)

## plot module ##
#plotModule(pvalue_annotation=test_annotation, which.network=1)

}
\keyword{ SMITE }
\keyword{ network }

\name{makePvalueObject}
\alias{makePvalueObject,PvalueAnnotation-method}
\alias{makePvalueObject}
\title{
Function to make a PvalueObject within a PvalueAnnotation}
\description{
Having annotated modifications and expression data this function will assemble
a PvalueObject within the slot "score_data" of a PvalueAnnotation.  This
is a necessary step before being able to run downstrem functions.
}
\usage{
makePvalueObject(pvalue_annotation, effect_directions = NULL)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation
}
  \item{effect_directions}{
A character vector with optional names specifying
                "increase"  Modification is expected to increase as expression
                            increase
                "decrease"  Modification is expected to descrease as 
                            expression decreases
                "bidirectional"
                            No direction is assumed between modification and
                            direction
}
}
\details{
The specified relationship between the modification and expression will be 
stored and then used when scoring.
}
\value{
An S4 object of class PvalueAnnotation with a slot for score_data filled it
}
\author{
N.Ari Wijetunga
}

\seealso{
makePvalueAnnotation
}
\examples{
#NOTE: Commented out in example, please see vignette for more details##
options(stringsAsFactors=FALSE)

data(methylationdata)
methylation <- methylation[-which(is.na(methylation[, 5])), ]
#methylation[, 5] <- replace(methylation[, 5],methylation[, 5] == 0, 
#min(subset(methylation[, 5], methylation[, 5] != 0), na.rm=TRUE))

#data(curated_expressiondata)
#data(hg19_genes_bed)
#data(histone_h3k4me1)

#test_annotation<-makePvalueAnnotation(data=hg19_genes, 
#other_data=list(h3k4me1=h3k4me1), gene_name_col=5,other_tss_distance=5000)

#fill in expression data
#test_annotation<-annotateExpression(test_annotation, expression_curated)


#fill in methylation data
#this step takes ~10 minutes
#test_annotation<-annotateModification(test_annotation, methylation, 
#weight_by=c(promoter="distance",body="distance",h3k4me1="distance"),
#verbose=TRUE, mod_corr=FALSE)

#create a pvalue object that will count the effect of the h3k4me1 as
#bidirectional
#test_annotation<-makePvalueObject(pvalue_annotation=test_annotation, 
#effect_directions=c(methylation_promoter="decrease",
#methylation_body="decrease", methylation_h3k4me1="bidirectional"))
}
\keyword{ SMITE }

\name{extractModification}
\alias{extractModification}
\alias{extractModification,PvalueAnnotation-method}
\alias{extractModSummary}
\alias{extractModSummary,PvalueAnnotation-method}
\title{
Extract some or all loaded modifications or a the summary of combined effects
}
\description{
After having loaded modifications into a PvalueAnnotation, these functions can 
be used to display the GRanges with the modification of interest, or the data
frame containg a summary of the combined effects.
}
\usage{
extractModification(pvalue_annotation, mod_type = "methylation")
extractModSummary(pvalue_annotation)
}

\arguments{
  \item{pvalue_annotation}{
An s4 object of calss PvalueAnnotation
}
  \item{mod_type}{
A string or character vector that must match one or more of the loaded 
modifications. If NULL (DEFAULT) then it will show all modifications.
}
}
\value{
A GRanges object containing the modification(s) of interest or a data frame with
a summary of the combined p-values and effects
}
\author{
N. Ari Wijetunga
}
\seealso{
extractExpression
annotateModificaiton
removeModification
}
\examples{
##NOTE: Comment out in exmaple see vignette for more detailed usage ##

## Load genome bed file ##
data(hg19_genes_bed)

## Load curated DNA methylation bed file ##
#data(methylationdata)
#methylation <- methylation[-which(is.na(methylation[,5])),]
#methylation[, 5] <- replace(methylation[,5],methylation[,5] == 0, 
#min(subset(methylation[, 5], methylation[, 5] !=0 ), na.rm=TRUE))

## Create a PvalueAnnotation with defaults for promoter size##
test_annotation<-makePvalueAnnotation(data=hg19_genes, gene_name_col=5)

## Load DNA methylation into PvalueAnnotation ##
#test_annotation <- annotateModification(pvalue_annotation=test_annotation, 
#methylation, weight_by=c(promoter="distance", body="distance"), verbose=TRUE,
#mod_corr=FALSE, mod_type="methylation")

## Extract GRanges with modification data ##
#extractModification(pvalue_annotation=test_annotation)

}
\keyword{ SMITE }
\keyword{ epigenetics }
\keyword{ networks }

\name{Reactome.Symbol.Igraph}
\alias{Reactome.Symbol.Igraph}
\alias{REACTOME}
\docType{data}
\title{
An Igraph network for REACTOME with nodes as gene symbols 
}
\description{
This is an Igraph network that was created using the REACTOME protein-protein 
interaction database.
}
\usage{data("Reactome.Symbol.Igraph")}
\format{
  An igraph object with 5770 nodes and 114288 edges
  \describe{
    \item{nodes}{gene names as gene symbols}
    \item{edges}{paired genes that interact}
  }
}
\details{
The provided igraph file was created using the igraph package and the 
interaction file provided from the reference. 
}
\value{
An Igraph network  based off of REACTOME interactions
}

\source{
REACTOME
}

\references{
http://www.reactome.org/pages/download-data/
}
\examples{
data(Reactome.Symbol.Igraph)
head(igraph::V(REACTOME))
}
\keyword{datasets}

\name{plotDensityPval}
\alias{plotDensityPval}
\alias{plotDensityPval,PvalueAnnotation-method}
\title{
Plot the density of the combined scores stored in a PvalueObject
}
\description{
This function in called by the normalizePval function, but can also be called
by the user to visualize the relative densities of combined p-values (scores). 
}
\usage{
plotDensityPval(pvalue_annotation, ref = "expression_pvalue", ...)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation.
}
  \item{ref}{
A character specifying the name of the reference category. DEFAULT is 
"expression_pvalue"
}
\item{...}{
 Additional plotting arguments
 }
}
\value{
Plots a multidensity plot.
}
\author{
N. Ari Wijetunga
}
\examples{
## Load test annotation with only score data ##
data(test_annotation_score_data)

plotDensityPval(pvalue_annotation=test_annotation)

}
\keyword{ density }
\keyword{ SMITE }

\name{extractExpression}
\alias{extractExpression}
\alias{extractExpression,PvalueAnnotation-method}
\title{
View the expression data stored in a PvalueAnnotation
}
\description{
This function allows the user to see the effect and p-value data that was loaded
into a PvalueAnnotation before performing downstream analysis.
}
\usage{
extractExpression(pvalue_annotation)
}

\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation for which expression data has already
been loaded via annotateExpression
}
}
\value{
A data.frame pulled from the phenoData of the expression slot within a load
PvalueAnnotation.  The phenoData specifically hold the effect and p-value
information.
}
\author{
N. Ari Wijetunga
}
\seealso{
annotateExpression
}
\examples{
data(test_annotation_score_data)
data(curated_expressiondata)
## Load Expression data into PvalueAnnotation ##
test_annotation<-annotateExpression(test_annotation, expression_curated)

## Extract entire ExpressionSet with expression data ##
#slot(test_annotation,"expression")

## Extract expression data summary ##
head(extractExpression(pvalue_annotation=test_annotation))


}
\keyword{ SMITE }
\keyword{ expression }

\name{annotateModification}
\alias{annotateModification}
\alias{annotateModification,PvalueAnnotation-method}
\title{
Adding modification data to a PvalueAnnotation
}
\description{
This function is the main "workhorse" function for SMITE because given a 
specific epigenetic modification (e.g. DNA methylation) it will 1) assess
an internal correlation structure and 2) aggregate the modification over all 
intervals associated with a gene in the "makePvalueAnnotation" function.
}
\usage{
annotateModification(pvalue_annotation, mod_data, weight_by = NULL, 
weight_by_method = "Stouffer", mod_included = NULL, mod_corr = TRUE, 
mod_type = "methylation", verbose = FALSE)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation.
}
  \item{mod_data}{
A dataframe or matrix derived from a bed file with thhe the first three columns
as (chromosome, start, end), column 4 is the effect, and column 5 is the
p-value.
}
  \item{weight_by}{
A vector with named elements specifying how modifications should be weighted 
within an interval.  Must be one of:
    
    "distance"  Use the distance from the gene TSS to weight the p-values
                and the combined effect such that events closer to the
                TSS are weighted more.  Log distances are used.
    
    "pval" 
    "p.value"
    "pvalue"
    "p_val"     (DEFAULT) Do not weight p-values but weight the combined 
                effect such by the signficance of that effect.
     
     ELSE       Do not weight p-values or the combined effect.
    
}
  \item{weight_by_method}{
A character specifying which method should be used to combine 
p-values.  Must be one of:

    "Stouffer"  (DEFAULT)
                Stouffer's method for combing pvalues involves first taking the 
                inverse standard normal
                CDF transformation of a vector of p-values followed by a 
                weighted sum
                creating a new Z score with a standard normal distribution
    "Fisher"
    "fisher"
    "chisq"
    "chi"
                Fisher's method involves summing the -2ln(p) for each of k p's
                which follows an approximate
                chi square distribution with 2k degrees of freedom
    "Sidak"
    "sidak"
    "minimum"
                Sidak's adjustment is essentially the minimum p-value, with an 
                added transformation to account for
                multiple comparisons.
    "binomial"
                The binomial probability assesses the probability of observing 
                the observed number of p-value below a threshold (alpha=0.05) 
                given the total number of p values and the probability of a 
                false positive.
}
  \item{mod_included}{
A vector of named elements specifying for which intervals in the annotation the
function should find combined scores (e.g. promoters).  If not specified the
assumption is that all type of intervals associated with a gene should be 
included.
}
  \item{mod_corr}{
A logical (TRUE/FALSE) specifying whether a correlation matrix should be
estimated.  The DEFAULT is TRUE.
}
  \item{mod_type}{
A character naming the modification that is being loaded.  The DEFAULT is
"methylation" and any modType string can be used, but will be referred to 
in downstream analysis.  A unique name must be used for each modification that 
is loaded.  When picking a variable modType should also avoid using "_" as it is
used to split column names containing modType.
}
  \item{verbose}{
A logical specifying if the user wants updates about the progress of the
function.
}
}
\details{
This function is the main "workhorse" function for SMITE because given a 
specific epigenetic modification (e.g. DNA methylation) it will 1) assess
an internal correlation structure and 2) aggregate the modification over all 
intervals associated with a gene in the "makePvalueAnnotation" function.

}
\value{
A an S4 object of class PvalueAnnotation with the slot modification 
(a GrangesList) filled in for each additional modification.
}
\references{
Fisher R. Statistical methods for research workers. Oliver and Boyd; 
Edinburgh: 1932.

Stouffer S, DeVinney L, Suchmen E. The American soldier: 
Adjustment during army life. Vol. 1. Princeton University Press; 
Princeton, US: 1949.

Sidak, Z. (1967). Rectangular confidence regions for the means of
multivariate normal distributions, Journal of the American Statistical 
Association 62, 626 633.
}
\author{
N. Ari Wijetunga
}
\seealso{
removeModification
annotateExpression
makePvalueAnnotation
createPvalueObject
}
\examples{
options(stringsAsFactors=FALSE)

## Commented out below See vignette for more detailed usage information ##
## Load genome bed file ##
#data(hg19_genes_bed)

## Create a PvalueAnnotation with defaults for promoter size##
#test_annotation<-makePvalueAnnotation(data=hg19_genes, gene_name_col=5)

## Load DNA methylation bed file ##
#data(methylationdata)
#methylation<-methylation[-which(is.na(methylation[,5])),]
#methylation[,5]<-replace(methylation[,5],methylation[, 5] == 0, 
#min(subset(methylation[,5], methylation[,5]!=0), na.rm=TRUE))

## Load DNA methylation into PvalueAnnotation modCorr=F for example##
## NOTE: Commented out below.  See vignette for better example ##
#test_annotation <- annotateModification(pvalue_annotation=test_annotation, 
#mod_data=methylation, weight_by=c(promoter="distance", body="distance"),
#verbose=FALSE, mod_corr=FALSE, mod_type="methylation")

}
\keyword{ SMITE }
\keyword{ epigenetic }

\name{runGOseq}
\alias{runGOseq}
\alias{runGOseq,PvalueAnnotation-method}
\title{
Run a GoSeq pathway analysis
}
\description{
This function allows pathway annotation of identified modules.
}
\usage{
runGOseq(pvalue_annotation, p_thresh = 0.05, supply_cov=TRUE, coverage=NULL, type = "reactome")
}

\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation, for which module-finding has already 
been performed
}
  \item{p_thresh}{
A numeric specifying a threshold for signficance of FDR (q-values). DEFAULT is
alpha=0.05
}
  \item{supply_cov}{
A logical specifying whether or not the user wants to supply their own coverage (TRUE), or would like SMITE to calculate the coverage based on methylation data already inputted. DEFAULT is TRUE.
}
  \item{coverage}{
A data.frame that is a bed file (chr  start stop) folowed by a gene name and
a numeric specifying the bias data (e.g. gene length or number of probes related
to gene). DEFAULT is null}
  \item{type}{
Either "kegg" to run KEGG analysis or "reactome" to run a REACTOME analysis
}
}
\details{
Goseq analysis is useful since it allows you to assess term/pathway enrichment
in a collection of genes, while adjusting for bias data.  Potential bias
can be from aspects like gene length or probe density that influence the
likelihood of finding a particular gene.  For more information please see
the goseq reference.

The function will compare all of the genes within a module to known pathways and
terms to find the terms that are most enriched within a module.  In this way,
this tool allows a reasearch to find a functional importance of a module.

We currently offer KEGG and REACTOME analysis, although additional pathway tools
may be added in the near future.

}
\value{
A PvalueAnnotation with goseq annotated modules.
}
\references{
Young MD, Wakefield MJ, Smyth GK and Oshlack A (2010). 
Gene ontology analysis for RNA-seq: accounting for selection bias. 
Genome Biology, 11, pp. R14.
}
\author{
Matthew D. Young myoung at wehi.edu.au
}
\note{
This is a wrapper function written by N. Ari Wijetunga for the package SMITE.
}

\seealso{
searchGOseq
extractGOseq
runSpinglass
runBioNet
extractModules
plotModule
}
\examples{
##load sample data with only PvalueObject filled in##
data(test_annotation_score_data)

## NOTE commented out in example.  Please see Vignette for better example ##
#test_annotation<-runGOseq(pvalue_annotation=test_annotation,
#coverage=read.table(
#system.file("extdata", "hg19_symbol_hpaii.sites.inbodyand2kbupstream.bed.gz", 
#package="SMITE"),stringsAsFactors=FALSE),type="kegg")


## search for a term ##
searchGOseq(test_annotation,"Cell cycle")

## show goseq analysis for module 1 ##
#extractGOseq(test_annotation,1)

}

\keyword{ goseq }
\keyword{ SMITE }

\name{annotateExpression}
\alias{annotateExpression}
\alias{annotateExpression,PvalueAnnotation-method}
\title{
Adding expression data to a PvalueAnnotation
}
\description{
This function is used to create and load an ExpressionSet into a 
PvalueAnnotation.  Using specified effect and p-value column or named columns 
that the function will use to determine the effect and p-value columns, it loads 
the data it into the PvalueAnnotation. 
}
\usage{
annotateExpression(pvalue_annotation, expr_data, effect_col = NULL, pval_col = NULL)
}
\arguments{
    \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation
}
    \item{expr_data}{
An object of class data.frame or matrix with row names corresponding to 
genes and atleast two columns with an effect and p-value for expression.

}
    \item{effect_col}{
A numeric specifying the column with an effect direction.  If not specified the 
function will grep for a single named column from: "effect", "odds",
"coeff" or "B"
}
    \item{pval_col}{
A numeric specifying the column with p-values.  If not specified the 
function will grep for a single named column from: "pval","p.val","p_val"
or "sig"
}
}
\details{
The function will load the entire given expression dataset as an ExpressionSet
in the expression slot,while the effect and p-value data will also be stored as 
an "AnnotatedDataFrame" in the phenoData slot of the ExpressionSet.
}
\value{
A PvalueAnnotation, an S4 object with the slot "expression" filled in.
}
\author{
N. Ari Wijetunga
}
\seealso{
annotateModification
makePvalueAnnotation
createPvalueObject
}
\examples{

data(curated_expressiondata)
data(test_annotation_score_data)
## Load Expression data into PvalueAnnotation ##
test_annotation <- annotateExpression(pvalue_annotation=test_annotation, 
expression_curated)

## Extract entire ExpressionSet with expression data ##
#slot(test_annotation,"expression")

## Extract expression data summary ##
#head(extractExpression(pvalue_annotation=test_annotation))

}
\keyword{ expression }
\keyword{ SMITE }

\name{SMITE-package}
\alias{SMITE-package}
\alias{SMITE}
\docType{package}
\title{
Significance-based Modules Integrating the Transcriptome and Epigenome
}
\description{
SMITE provides a method of scoring and visualizing multi-level epigenomic data 
in order to prioritize genes within a genome-wide experiment.  These scores can 
then be used to identify subnetworks within an interaction network
called modules.  Each module represents a collection of highly interacting genes
that are implicated by the experiment.
}
\details{
\tabular{ll}{
Package: \tab SMITE\cr
Type: \tab Package\cr
Version: \tab 1.0.0\cr
Date: \tab 2015-07-06\cr
License: \tab GPL (>=2)\cr
}
}
\author{
Neil Ari Wijetunga,
Andrew Damon Johnston

Maintainer: Neil.Wijetunga@med.einstein.yu.edu, Andrew.Johnston@med.einstein.yu.edu
}

\keyword{ package }
\seealso{
FEM
BioNet
}
\examples{
## NOTE: commented out for example.  See vignette for better explanation ##

options(stringsAsFactors=FALSE)

data(methylationdata)
methylation <- methylation[-which(is.na(methylation[, 5])), ]
methylation[,5] <- replace(methylation[,5],methylation[,5] == 0, 
    min(subset(methylation[,5], methylation[,5]!=0), na.rm=TRUE))

data(curated_expressiondata)

data(hg19_genes_bed)
data(histone_h3k4me1)

#test_annotation<-makePvalueAnnotation( data=hg19_genes, 
#other_data=list(h3k4me1=h3k4me1), gene_name_col=5, other_tss_distance=5000)

##fill in expression data
#test_annotation<-annotateExpression(test_annotation, expression_curated)


##fill in methylation data

#test_annotation<-annotateModification(test_annotation, methylation, 
#weight_by=c(promoter="distance", body="distance", h3k4me1="distance"),
#verbose=TRUE, mod_corr=TRUE)

##create a pvalue object that will count the effect of the h3k4me1 as
##bidirectional

#test_annotation<-makePvalueObject(test_annotation, 
#effect_directions=c(methylation_promoter="decrease",
#methylation_body="decrease",
#methylation_h3k4me1="bidirectional"))

##normalize the pvalues compared to colExp

#test_annotation<-normalizePval(test_annotation,ref="expression_pvalue",
#method="rescale")
    
##score with all four features contributing

#test_annotation<-SMITEscorePval(test_annotation,
#weights=c(methylation_promoter=.3,methylation_body=.1,expression=.3,
#methylation_h3k4me1=.3))

##load REACTOME 
#load(system.file("data","Reactome.Symbol.Igraph.rda", package="SMITE"))
 
##run Spinglass using REACTOME network

#test_annotation<-runSpinglass(test_annotation, REACTOME, maxsize=50, 
#num_iterations=10)

##run goseq on individual modules to determine bias 
#test_annotation <- runGOseq(test_annotation,
#coverage=read.table(system.file("extdata", 
#"hg19_symbol_hpaii.sites.inbodyand2kbupstream.bed.gz", package="SMITE")),
#type="kegg")

##search go seq output for keywords
#searchGOseq(test_annotation, "Cell")

##Draw a network
#plotModule(test_annotation, which_network=6, layout="fr")

##sample final file ##
data(test_annotation_score_data)


}

\name{plotModule}
\alias{plotModule}
\alias{plotModule,PvalueAnnotation-method}
\title{
Plot a specific module after running Spinglass algorithm
}
\description{
This function is an adapted version of renderModule available through Epimods.
We have added optional functionality including plotting the actual raw data
onto the node edges, adding goseq annotation to the plot, legends and plotting 
modes.
}
\usage{
plotModule(pvalue_annotation, p_thresh = 0.05, which_network = 1, goseq = FALSE, 
layout = "fr", legend = TRUE, namestyle = "symbol", suppress_details = FALSE, 
meth_hi_col = "blue", meth_low_col = "yellow1", 
meth_mid_col = "gray90", exp_hi_col = "red1", exp_low_col = "chartreuse1", 
exp_mid_col = "gray90", label_scale = TRUE, label_shadow = FALSE, compare_plot=FALSE, 
pdf_out=NULL)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation
}
  \item{p_thresh}{
A numeric specifying a threshold for plotting raw data on edges of
nodes.  DEFAULT is alpha=0.05.  Items above this threshold will be classified as
"mid" instead of "high" or "low"
"}
  \item{which_network}{
A numeric specifying which network to plot.  DEFAULTS to 1, and will
not plot another network until specified explicitly.
}
  \item{goseq}{
A logical indicating whether to plot goseq results for the module on the right 
hand side of the plot.
}
  \item{layout}{
A character string  as either "fr" (DEFAULT) for fruchterman.reingold or 
"circle" for a circular plot.
}
  \item{legend}{
A logical (TRUE(DEFAULT)/FALSE) specifying whether a legend should be drawn.
}
  \item{namestyle}{
A character string as either "symbol" (DEFAULT) for gene symbols or "refseq" for
RefSeq genes.  If modules were performed on RefSeq genes, then the function will
plot with gene symbols so that it is more useful.
}
  \item{suppress_details}{
A logical (TRUE(DEFAULT)/FALSE) indicating whether border raw data information 
should be plotted.
}
  \item{meth_hi_col}{
A color to be associated with signficant modification data with
positive effects
}
  \item{meth_low_col}{
A color to be associated with signficant modification data with
negative effects}
  \item{meth_mid_col}{
A color to be associated with non-signficant modification data 
}
  \item{exp_hi_col}{
A color to be associated with signficant expression data with
postive effects
}
  \item{exp_low_col}{
A color to be associated with signficant expression data with
negative effects}
  \item{exp_mid_col}{
A color to be associated with non-signficant expression data 
}
  \item{compare_plot}{
A logical (TRUE/FALSE(DEFAULT)) indicating whether two plots should be drawn 
side by side, one with raw data and one without
}
  \item{label_scale}{
A logical (TRUE(DEFAULT)/FALSE) indicating whether whether the node label should
be scaled with the node score
}
  \item{label_shadow}{
A logical (TRUE/FALSE(DEFAULT)) indicating whether whether the node label should
have a white text shadow for easier label reading
}
  \item{pdf_out}{
A string indicating a location to which the function should output a pdf.  If 
NULL (DEFAULT) then no pdf is made.
}

}

\value{
A plot of the module
}
\author{
N. Ari Wijetunga}
\seealso{
extractModules
}
\examples{
data(test_annotation_score_data)

#plotModule(pvalue_annotation=test_annotation, which_network=2)

#plotModule(pvalue_annotation=test_annotation, which_network=2,
#suppressDetails=TRUE)
}

\name{plotCompareScores}
\alias{plotCompareScores}
\alias{plotCompareScores,PvalueAnnotation-method}
\title{
Compare two genomic features by score and display them in a hexbin plot
}
\description{
This function creates a hexbin of the log transformed p-value/score for any
two expression or modification-context pairing within a PvalueObject 
inside of a PvalueAnnotation
}
\usage{
plotCompareScores(pvalue_annotation, x_name, y_name, ...)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation for which a PvalueObject has already
been created
  }
  \item{x_name}{
A string to be grepped from the columns within the slot "pval_data" that is
within the PvalueAnnotation slot "score_data."  This column will be plotted on
the x-axis with a  direction specified from the corresponding effect column. 
}
  \item{y_name}{
A string to be grepped from the columns within the slot "pval_data" that is
within the PvalueAnnotation slot "score_data."  This column will be plotted on
the y-axis with a  direction specified from the corresponding effect column.
}
  \item{\dots}{
Other plotting parameters
}
}
\details{
This plotting function creates a hexbin plot of any two p-value vectors
stored within a p-value object.  It can be used to define relationships
between direction and significance in different genomic contexts after 
having combined p-values.
}
\value{
A hexbin plot
}
\author{
N. Ari Wijetunga
}
\seealso{
makePvalueObject
plotDensityPval
}
\examples{
data(test_annotation_score_data)

plotCompareScores(pvalue_annotation=test_annotation, x_name="expression", 
y_name="methylation_promoter")
}

\name{stoufferTest}
\alias{stoufferTest}
\alias{stoufferTest,vector-method}
\title{
Stouffer's Test
}
\description{
This function performs a weighted Stouffer's mehtod of combining p-values.
}
\usage{
stoufferTest(pvalues, weights)
}
\arguments{
  \item{pvalues}{
A vector of p-values.
}
  \item{weights}{
Optional weights used when combining probabilites.  If no weights are given then the p-values are equally weighted.
}
}
\details{
For each p-value the inverse standard normal CDF is applied and  Z scores 
are derived. Z-scores are then summed and a new Z score is transformed back to 
a p-value.
}
\value{
A numeric p-value that represents the standard normal CDF of the combined 
Z statistic.
}
\references{

https://en.wikipedia.org/wiki/Fisher's_method

Stouffer S, DeVinney L, Suchmen E. The American soldier: Adjustment during army life. Vol. 1. Princeton University Press; Princeton, US: 1949.

}
\note{
This function was adapted from the function written on the Fisher's Method
wikipedia page.
}
\examples{
## Generate test weights ##
weights<-runif(10, 1,100)
weights<-sort(weights)

## Generate test p-values##
pvals<-runif(10,0,1)

## run stoufferTest ##
stoufferTest(pvalues = pvals, weights=1/weights)

}
\keyword{ pvalues }
\keyword{ significance }

\name{extractGOseq}
\alias{extractGOseq}
\alias{searchGOseq}
\alias{searchGOseq,PvalueAnnotation-method}
\alias{extractGOseq,PvalueAnnotation-method}
\title{
 View the GOseq pathway analysis after having run Goseq, or search for a term.
}
\description{
Having defined at least one genomic module using runSpinglass or 
runBioNet, this function allows you to interrogate the enriched terms for a
specific module or combination of modules.
}
\usage{
extractGOseq(pvalue_annotation, which_network = NULL)
searchGOseq(pvalue_annotation, search_string, wholeword = FALSE)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation, for which module-finding and GOseq 
analysis have already been performed
}
  \item{which_network}{
A numeric vector of a length of at least one, corresponding to a particular 
functional module specifically for the extract function.
}
 \item{search_string}{
A character specfying a search string specifically for the search function.
}
  \item{wholeword}{
A logical (TRUE/FALSE) detemring whether the search string must be matched for
whole word specifically for the search function.
}
}
\details{
Goseq analysis is useful since it allows you to assess term/pathway enrichment
in a collection of genes, while adjusting for bias data.  Potential bias
can be from aspects like gene length or probe density that influence the
likelihood of finding a particular gene.  For more information please see
the goseq reference.
}
\value{
##Extract##
A list with eahc element matching the specified module.  Has columns 
identfying the term id, the over represented p-value, underrepresented 
p-value the total number in the category found in the module, the total
number in the category and a more descirptive pathway name. 


##Search##
A matrix with columns identfying the module name, module position/significance
, the specific enriched term, the rank of that term within all enriched terms 
and the total number of enriched terms.
}
\references{
Young MD, Wakefield MJ, Smyth GK and Oshlack A (2010). 
Gene ontology analysis for RNA-seq: accounting for selection bias.
Genome Biology, 11, pp. R14.
}
\author{
N. Ari  Wijetunga
}

\seealso{
runGOseq
runSpinglass
runBioNet
extractModules
plotModule
}
\examples{

## Commented out below.  See vignette for more details ##

##load sample data with only PvalueObject filled in##
data(test_annotation_score_data)

## show goseq analysis for module 1 ##
extractGOseq(test_annotation, 1)

## show goseq analysis for module 1 and 2 ##
#extractGOseq(test_annotation, 1:2)

## search for term ##

#searchGOseq(test_annotation, "Cell cycle")
}

\keyword{ goseq }
\keyword{ SMITE }

\name{curated_expressiondata}
\alias{curated_expressiondata}
\alias{expression_curated}
\docType{data}
\title{
A toy dataset ofcurated RNA-seq to test within SMITE
}
\description{
A toy dataset of pre-cleaned gene expression data from RNA-seq.  The file is 
effect and p-value with gene names as rownames.
}
\usage{data("curated_expressiondata")}
\format{
  A data frame with 20819 observations on the following 2 variables.
  \describe{
    \item{rownames}{a character vector specifying gene}
    \item{column1}{an numeric vector specifying effect (log fold change)}
      \item{column2}{a numeric vector with a two sided p-value from DESeq 
      analysis}
  }
}
\value{
A dataframe with rownames as genes in Refseq format and columns for effects
and pvalues derived from negative binomial testing of DESeq normalized 
values from RNA-seq.
}
\details{
This gene expression dataset is a randomized version of the Toxoplasma dataset 
used to benchmark 
SMITE.  It no longer has NAs or  p-values=0.  Gene names were converted to gene 
symbols.
}
\source{
Manuscript in preparation.  Please see 
https://github.com/GreallyLab 
for more details.}
\examples{
data(curated_expressiondata)
}
\keyword{datasets}

\name{addShadowText}
\alias{addShadowText}
\alias{addShadowText,ANY-method}
\title{
Add shadow text (a second color bordering the text) to a plot
}
\description{
This is a usefule function to help text stand out on busy backgrounds
like gene networks
}
\usage{
addShadowText(x, y = NULL, labels, col = "white", bg = "black", 
theta = seq(pi/4, 2 * pi, length.out = 8), r = 0.1, ...)
}
\arguments{
    \item{x}{
A numeric vector of x coordinates
}
    \item{y}{
A numeric vector of y coordinates
}
    \item{labels}{
A character vector to be plotted at the specified coordinates
}
    \item{col}{
The text color
}
    \item{bg}{
The color of the outline
}
    \item{theta}{
The number of shadows to plot
}
    \item{r}{
The radius for the shadows
}
    \item{...}{
 Additional plotting arguments
}}
\details{
The function creates its effect by plotting theta shadows at r radius around the
text to create the illusion of a text shadow
}
\value{
Adds shadow text to plot
}
\references{
http://article.gmane.org/gmane.comp.lang.r.general/147787
}
\author{
Greg.Snow <at> imail.org
}
\note{
This function was adapted by N. Ari Wijetunga for SMITE.
}

\seealso{
text, mtext
}
\examples{
plot.new()

addShadowText(x = .5,y = .5,"TEST",col="white",bg="gray")


}
\keyword{ aplot }

\name{highScores}
\alias{highScores}
\alias{highScores,PvalueAnnotation-method}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Generate a vector of the highest scoring genes
}
\description{
This function can be used to extract a subset of the highest scoring genes for
other downstream analysis. 
}
\usage{
highScores(pvalue_annotation, alpha = 0.05)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation for which scoring has already been
performed
}
  \item{alpha}{
A numeric specifying a threshold at signficant genes can be determined. DEFAULT
is alpha=0.05.
}
}
\details{
This function randomly samples the scores with replacement 100 times and for
within each random sample for each score it determines the proportion of scores
at or greater than the score. The average of these proportions over the 100 
samples will be the new p-value/scores.  All scores falling below the threshold
will be returned.

}
\value{
A named vector of scores.
}
\author{
N. Ari Wijetunga
}
\seealso{
scorePval
plotCompareScores
runSpinglass
runBioNet
}
\examples{
data(test_annotation_score_data)


## Note: commented out for example.  See vignette for better example ##

#out <- highScores(pvalue_annotation=test_annotation, alpha=0.01)

}
\keyword{ nonparametric }
\keyword{ genes }

\name{methylationdata}
\alias{methylationdata}
\alias{methylation}
\docType{data}
\title{
A toy dataset of DNA methylation to test within SMITE
}
\description{
A toy dataset of raw DNA methylation from HELP-tagging.  The file is a 
BED file with columns added for effect and p-value.
}
\usage{data(methylationdata)}
\format{
  A data frame with 40000 observations on the following 5 variables.
  \describe{
    \item{column1}{a character vector specifying chromsome}
    \item{column2}{an integer vector specifying start}
    \item{column3}{an integer vector specifying end}
    \item{column4}{a numeric vector with an effect direction (here it is average
    difference between two groups)}
    \item{column5}{a numeric vector with a two sided t-test p-value}
  }
}
\details{
This is a small subset of a DNA methylation dataset is a randomized version of 
the Toxoplasma dataset used to benchmark.  We could not include the larger
version do to package size requirements but larger versions are available.
See Github source below. It still has NAs and p-values=0.
}
\source{
Manuscript in preparation. Please see https://github.com/GreallyLab/SMITE 
for more details.
}
\value{
A dataframe in BED format (chromosome, start, end) with additional columns for
and effect direction and p-value derived from T-tests of HELP-tagging DNA
methylation data.
}
\examples{
data(methylationdata)

any(is.na(methylation[, 4]))

any(methylation[, 4] == 0)
}
\keyword{datasets}

\name{histone_h3k4me1}
\alias{histone_h3k4me1}
\alias{h3k4me1}
\docType{data}
\title{
A toy dataset of H3k4me1 peaks to test within SMITE
}
\description{
A toy dataset of H3k4me1 peaks from liver ChIP-seq through the encode project.  
The file is a 
BED file.
}
\usage{data(histone_h3k4me1)}
\format{
  A data frame with 75448 observations on the following 3 variables.
  \describe{
    \item{column1}{a character vector specifying chromsome}
    \item{column2}{an integer vector specifying start}
    \item{column3}{an integer vector specifying end}
  }
}
\details{
This is a BED file that specifices the consensus locations of three H3K4me1 
ChIP-seq experiments performed on normal adult liver.
}
\value{
A dataframe in BED format (chromosome, start, end).
}
\source{
GSM669972, GSM621654, GSM537706

Roadmap Epigenomics
Lister R, et al. Nature. 2009 Nov 19;462(7271):315-22
ENCODE Project Consortium. An integrated encyclopedia of DNA elements in the 
human genome. Nature. 2012 Sep 6;489(7414):57-74.

}

\examples{
data(histone_h3k4me1)
head(h3k4me1)
}
\keyword{datasets}

\name{extractModules}
\alias{extractModules}
\alias{extractModules,PvalueAnnotation-method}
\title{
View specific modules within a PvalueAnnotation
}
\description{
Having identfied modules within a Pvalue annotation, this function allows the user to display 1 or more of the module genes.
}
\usage{
extractModules(pvalue_annotation, which_module = NULL)
}
\arguments{
  \item{pvalue_annotation}{
An S4 object of class PvalueAnnotation for which Spinglass or BioNet has already been run.
}
  \item{which_module}{
A numeric vector specifying one or more module to display
}
}
\value{
A list with each element containing the requested modules
}
\author{
N. Ari Wijetunga
}
\seealso{
plotModule
runGOseq
extractGOseq
runSpinglass
runBioNet
}
\examples{
data(test_annotation_score_data)

extractModules(pvalue_annotation=test_annotation, which_module=1)

}
